*DECK B1SOL
      SUBROUTINE B1SOL (NGRO,B,IER)
*
*-----------------------------------------------------------------------
*
* SOLUTION OF A SYSTEM OF LINEAR EQUATIONS THAT APPEAR IN A B1 METHOD.
* USE ALSBD FOR SOLUTION IN THERMAL GROUPS.
*
* INPUT PARAMETERS:
*  NGRO    : ORDER OF THE COEFFICIENT MATRIX.
*  B       : COEFFICIENT MATRIX AUGMENTED WITH THE RIGHT HAND VECTOR.
*            DIMENSION B(NGRO,NGRO+1)
*
* OUTPUT PARAMETERS:
*  B       : SOLUTION VECTOR, STARTING AT B(1,NGRO+1).
*  IER     : ERROR FLAG. EXECUTION FAILURE IF IER.NE.0.
*
*-------------------------------------- AUTHOR: A. HEBERT 21/01/91 -----
*
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION B(NGRO,*)
      IER=0
      NGROIN=0
      DO 30 I=1,NGRO
      DO 10 J=I+1,NGRO
      IF(B(I,J).NE.0.0D0) GO TO 40
   10 CONTINUE
      NGROIN=I
      IF(B(I,I).EQ.0.0D0) THEN
        IER=-1
        RETURN
      ENDIF
      ZGAR=B(I,NGRO+1)
      DO 20 J=1,I-1
   20 ZGAR=ZGAR-B(I,J)*B(J,NGRO+1)
   30 B(I,NGRO+1)=ZGAR/B(I,I)
   40 IF(NGROIN.EQ.NGRO) RETURN
      DO 60 I=NGROIN+1,NGRO
      ZGAR=B(I,NGRO+1)
      DO 50 J=1,NGROIN
   50 ZGAR=ZGAR-B(I,J)*B(J,NGRO+1)
   60 B(I,NGRO+1)=ZGAR
      CALL ALSBD(NGRO-NGROIN,1,B(NGROIN+1,NGROIN+1),IER,NGRO)
      RETURN
      END
