*DECK CPOISO
      SUBROUTINE CPOISO(IPEDIT,IPRINT,IEXTRC,NMERGE,MAXISO,MAXISM,
     >                  NBMICR,NIFISS,NISCPO,NISEXT,ISOCPO,ISOEXT,
     >                  ISOORD,ISOFIS,MIXFIS,ISOTMP,IMXTMP,IDETMP,
     >                  IDIMIX,NBIMRG,ICOMIX)
C
C-----------------------------------------------------------------------
C
C IDENTIFY ISOTOPES TO BE EXTRACTED FROM MACROSCOPIC XS
C AND ISOTOPES INCLUDED IN NEW COMBINED ISOTOPES.
C
C INPUT PARAMETERS:
C  IPEDIT  : POINTER TO EDIT INFORMATION (L_EDIT SIGNATURE).
C  IPRINT  : PRINT LEVEL
C  IEXTRC  : TYPE OF EXTRACTION: 1 FOR PART 2 FOR ALL
C  NMERGE  : NUMBER OF REGION
C  MAXISO  : MAXIMUM NUNBER OF ISOTOPES PERMITTED
C  MAXISM  : MAXIMUM NUNBER OF ISOTOPES PER REGION
C  NBMICR  : MAXIMUM NUMBER OF ISOTOPES IN EDIT
C  NIFISS  : NUMBER OF FISSILE ISOTOPES IN EDIT
C  NISCPO  : NUMBER OF CPO ISOTOPES TREATED
C  NISEXT  : NUMBER OF EXTRACTED ISOTOPES TREATED
C  ISOCPO  : CPO NAME OF ISOTOPES ISOCPO(3,MAXISO)
C  ISOEXT  : NAME OF EXTRACTED ISOTOPES ISOEXT(3,MAXISO)
C  ISOORD  : LOCATION OF EXTRACTED ISOTOPES IN CPO ISOORD(MAXISO)
C  ISOFIS  : NAME OF FISSILE ISOTOPES ISOFIS(2,(NIFISS+1))
C  MIXFIS  : MATERIAL OF FISSILE ISOTOPES MIXFIS(NMERGE,(NIFISS+1))
C  ISOTMP  : NAME OF ISOTOPES IN EDIT ISOTMP(3,NBMICR)
C  IMXTMP  : MIXTURE OF ISOTOPES IN EDIT IMXTMP(NBMICR)
C  IDETMP  : EXTRACTED ISOTOPES NUMBER ASSOCIATED WITH
C            EDIT ISOTOPE IDETMP(NBMICR)
C OUTPUT PARAMETERS:
C  IDIMIX  : ISOTOPES IDENTIFIER IN EACH CPO MATERIAL
C            IDIMIX(NMERGE,NBMICR)
C  NBIMRG  : FINAL NUMBER OF ISOTOPE PER REGION
C            NBIMRG(NMERGE)
C  ICOMIX  : POINTER TO CPO ISOTOPE FOR REGION
C            ICOMIX(NMERGE,MAXISM)
C
C------------------------------------- AUTHOR: A. HEBERT  ; 02/02/93 ---
C----------------------------------- MODIFIED: G. MARLEAU ; 97/07/10 ---
C
      IMPLICIT      NONE
      INTEGER       IPEDIT,IPRINT,IEXTRC,NMERGE,MAXISO,MAXISM,NBMICR,
     >              NIFISS,NISCPO,NISEXT,ISOCPO(3,MAXISO),
     >              ISOEXT(3,MAXISO),ISOORD(MAXISO),
     >              ISOFIS(2,(NIFISS+1)),MIXFIS(NMERGE,(NIFISS+1)),
     >              ISOTMP(3,NBMICR),IMXTMP(NBMICR),IDETMP(NBMICR),
     >              IDIMIX(NMERGE,NBMICR),NBIMRG(NMERGE),
     >              ICOMIX(NMERGE,MAXISM)
C----
C  LOCAL PARAMETERS
C----
      INTEGER       IOUT
      CHARACTER     TEXT4*4
      PARAMETER    (IOUT=6)
      INTEGER       ISOM,ISOE,ISOC,IMRG,IFIS,ITEXT4,ITC
C----
C  STORE IN ITEXT4 BLANCK STRING
C----
      TEXT4='    '
      READ(TEXT4,'(A4)') ITEXT4
C----
C  IF EXTRACT ALL USED (IEXTRC=2)
C  GENERATE ISOCPO, ISOEXT AND ISOORD
C  ASSOCIATE WITH ALL ISOTOPES EXTRACTED ISOTOPE NUMBER
C  NAMELY IDETMP(ISOM)=ISOEXT(ISOE)
C----
      IF(IEXTRC.EQ.2) THEN
        NISEXT=0
        DO 100 ISOM=1,NBMICR
          DO 110 ISOE=1,NISEXT
            IF(ISOEXT(1,ISOE).EQ.ISOTMP(1,ISOM).AND.
     >         ISOEXT(2,ISOE).EQ.ISOTMP(2,ISOM)) GO TO 115
 110      CONTINUE
          IF(NISEXT.EQ.MAXISO) THEN
            WRITE(IOUT,7000) MAXISO,ISOTMP(1,ISOM),ISOTMP(2,ISOM)
          ELSE
            NISEXT=NISEXT+1
            ISOEXT(1,NISEXT)=ISOTMP(1,ISOM)
            ISOEXT(2,NISEXT)=ISOTMP(2,ISOM)
            ISOEXT(3,NISEXT)=ITEXT4
            ISOCPO(1,NISEXT)=ISOTMP(1,ISOM)
            ISOCPO(2,NISEXT)=ISOTMP(2,ISOM)
            ISOCPO(3,NISEXT)=ITEXT4
            ISOORD(NISEXT)=NISEXT
            IDETMP(ISOM)=NISEXT
          ENDIF
 115      CONTINUE
 100    CONTINUE
        NISCPO=NISEXT
      ELSE
C----
C  IF SPECIFIC ISOTOPES EXTRACTED (IEXTRC=1)
C  FOR GENERIC EXTRACTED NAME (ISOEXT(3,ISOE)='    ')
C  ASSOCIATE WITH SET OF ISOTOPE EXTRACTED ISOTOPE NUMBER
C  NAMELY IDETMP(ISOM)=ISOEXT(ISOE)
C  FOR EXPLICIT EXTRACTED NAMES
C  ASSOCIATE WITH SPECIFIC ISOTOPE EXTRACTED ISOTOPE NUMBER
C  NAMELY IDETMP(ISOM)=ISOEXT(ISOE)
C----
        DO 120 ISOE=1,NISEXT
          IF(ISOEXT(3,ISOE).EQ.ITEXT4) THEN
            DO 130 ISOM=1,NBMICR
              IF(ISOEXT(1,ISOE).EQ.ISOTMP(1,ISOM).AND.
     >           ISOEXT(2,ISOE).EQ.ISOTMP(2,ISOM)) THEN
                IDETMP(ISOM)=ISOE
              ENDIF
 130        CONTINUE
          ELSE
            DO 140 ISOM=1,NBMICR
              IF(ISOEXT(1,ISOE).EQ.ISOTMP(1,ISOM).AND.
     >           ISOEXT(2,ISOE).EQ.ISOTMP(2,ISOM).AND.
     >           ISOEXT(3,ISOE).EQ.ISOTMP(3,ISOM)) THEN
                IDETMP(ISOM)=ISOE
              ENDIF
 140        CONTINUE
          ENDIF
 120    CONTINUE
      ENDIF
C----
C  IDENTIFY EXTRACTED ISOTOPES
C----
      DO 150 ISOM=1,NBMICR
        IMRG=IMXTMP(ISOM)
        ISOE=IDETMP(ISOM)
        IF(IMRG.NE.0.AND.ISOE.NE.0) THEN
          IDIMIX(IMRG,ISOM)=ISOORD(ISOE)
C----
C  TEST IF FISSILE ISOTOPE
C----
          IF(NIFISS.GT.0) THEN
            DO 151 IFIS=1,NIFISS
              IF(ISOFIS(1,IFIS).EQ.ISOTMP(1,ISOM).AND.
     >           ISOFIS(2,IFIS).EQ.ISOTMP(2,ISOM)) THEN
                IF(MIXFIS(IMRG,IFIS).EQ.IFIS) THEN
                  MIXFIS(IMRG,IFIS)=0
                ENDIF
              ENDIF
 151        CONTINUE
          ENDIF
        ENDIF
 150  CONTINUE
C----
C  COMPUTED NUMBER OF ISOTOPES PER MIXTURE
C----
      DO 160 IMRG=1,NMERGE
        NBIMRG(IMRG)=0
        DO 170 ISOM=1,NBMICR
          ISOC=IDIMIX(IMRG,ISOM)
          IF(ISOC.NE.0) THEN
            DO 180 ISOE=1,NBIMRG(IMRG)
              IF(ISOC.EQ.ICOMIX(IMRG,ISOE)) GO TO 185
 180        CONTINUE
            NBIMRG(IMRG)=NBIMRG(IMRG)+1
            ICOMIX(IMRG,NBIMRG(IMRG))=ISOC
 185        CONTINUE
          ENDIF
 170    CONTINUE
 160  CONTINUE
      IF(IPRINT.GE.1) THEN
        WRITE(IOUT,6000)
        DO 190 IMRG=1,NMERGE
          IF(NBIMRG(IMRG).GT.0) THEN
            DO 191 ISOM=1,NBMICR
              ISOC=IDIMIX(IMRG,ISOM)
              IF(ISOC.NE.0) THEN
                WRITE(IOUT,6001) IMRG,(ISOCPO(ITC,ISOC),ITC=1,3),
     >            (ISOTMP(ITC,ISOM),ITC=1,3)
              ENDIF
 191        CONTINUE
          ENDIF
 190    CONTINUE
      ENDIF
      RETURN
C----
C  PRINT FORMAT
C----
 6000 FORMAT(' CPO: LIST OF EXTRACTED ISOTOPES:'/
     > 10X,'REGION',10X,'CPO NAME    ',10X,'EDIT NAME   ')
 6001 FORMAT(10X,I6,10X,3A4,' CONTAINS ',3A4)
C----
C  WARNING FORMAT
C----
 7000 FORMAT(' CPOISO: ****** WARNING ******'/
     >       ' MAXIMUM NUMBER OF ISOTOPE REACHED = ',I8/
     >       ' SKIP GENERIC ISOTOPE NAME         = ',2A4/
     >       ' *****************************')
      END
