*DECK EDIDEL
      SUBROUTINE EDIDEL(IPRINT,NGCOND,NMERGE,IGR,SCATTD,INGSCT,IFGSCT,
     >                  IPOSCT,XSCAT,DELSCT)
C
C---------------------------  EDIDEL  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : EDIDEL
C      FUNCTION : SCATTERING DELTA SIGMA
C      MODIFIED : 97-02-10 (G.M.)
C                 91-04-08
C      AUTHOR   : G.MARLEAU
C
C  2- ROUTINE PARAMETERS:
C    INPUT
C      IPRINT   : PRINT LEVEL                        I
C                 = 1  PRINT DELTA SIGMAS
C      NGCOND   : NUMBER OF CONDENSED GROUPS         I
C      NMERGE   : NUMBER OF MERGED REGIONS           I
C      IGR      : CURRENT GROUP TREATED              I
C      SCATTD   : NEW SCATTERING MATRIX              D(NMERGE,
C                                                      NGCOND,NGCOND)
C      INGSCT   : NUMBER OF SCATTERING GROUPS(OLD)   I(NMERGE)
C      IFGSCT   : FIRST OLD SCATTERING GROUP         I(NMERGE)
C      IPOSCT   : POSITION OF REGION IN SCATT MATRIX I(NMERGE)
C      XSCAT    : NEW SCATTERING MATRIX              R(NMERGE*NGCOND)
C      DELSCT   : SCATTERING DELTA SIGMA             R(NGCOND)
C
C  3- INTERNAL PARAMETERS:
C      IOUT   : OUTPUT UNIT = 6                    I
C
C---------------------------   EDIDEL  --------------------------------
C
      IMPLICIT         NONE
      INTEGER          IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,NAMSBR='EDIDEL')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER          IPRINT,NGCOND,NMERGE,IGR
      INTEGER          INGSCT(NMERGE),IFGSCT(NMERGE),IPOSCT(NMERGE)
      REAL             XSCAT(NMERGE*NGCOND),DELSCT(NGCOND)
      DOUBLE PRECISION SCATTD(NMERGE,NGCOND,NGCOND)
C----
C  LOCAL PARAMETERS
C----
      INTEGER          IREG,JLASTG,JFRSTG,JPOSCT,JGR
C----
C  COMPUTE DELTA SIGMA BY MATERIAL FOR ALL GROUPS
C----
      DO 100 IREG=1,NMERGE
        JLASTG=IFGSCT(IREG)
        JFRSTG=JLASTG-INGSCT(IREG)+1
        JPOSCT=IPOSCT(IREG)+INGSCT(IREG)
        IF(IPRINT .GE. 1) THEN
          WRITE(IOUT,6000) IREG,NGCOND
        ENDIF
        DO 110 JGR=1,NGCOND
          IF(JGR.LT.JFRSTG .OR. JGR.GT.JLASTG) THEN
            DELSCT(JGR)=SCATTD(IREG,IGR,JGR)
          ELSE
            JPOSCT=JPOSCT-1
            DELSCT(JGR)=SCATTD(IREG,IGR,JGR)-XSCAT(JPOSCT)
          ENDIF
 110    CONTINUE
 100  CONTINUE
      WRITE(IOUT,6001) (DELSCT(JGR),JGR=1,NGCOND)
C
C------    FORMAT
C
 6000 FORMAT(/' REGION=',I5,10X,'NUMBER OF GROUPS ',I10)
 6001 FORMAT(1P,7(3X,E15.7))
      RETURN
      END
