*DECK EDIDST
      SUBROUTINE EDIDST(IPEDIT,IPRINT,NSTATS,NGCOND,NMERGE,NL    ,
     >                  NIFISS,NEDMAC,NTAUXT,NTENER,ENERGY,OLDNAM,
     >                  MXVAL ,MXERR ,
     >                  VOLMER,RATECM,SCATTD,FLXOLD,OLDRAT,VALER ,
     >                  INGSCT,IFGSCT,IPOSCT)
C
C---------------------------  EDIDST  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : EDIDST
C      USE      : REACTION RATES AND FLUXES STATISTICS
C      MODIFIED : 97-02-10 (G.M.)
C                 91-04-08 (G.M.)
C                 89-02-24 (G.M.)
C                 88-08-18 (G.M.)
C      AUTHOR   : G.MARLEAU
C
C  2- ROUTINE PARAMETERS:
C    INPUT
C      IPEDIT   : POINTER TO THE EDIT                I
C      IPRINT   : PRINT LEVEL                        I
C                 = 0  PRINT STATS RESULTS ONLY
C                 = 1  PRINT CURRENT RATES+ERRORS
C                 = 2  PRINT ALL RATES +ERRORS
C      NSTATS   : STATISTICS OPTIONS                 I
C                 = 1  FLUX STATS
C                 = 2  REACTION RATES STATS
C                 = 3  FLUX+REACTION RATES STATS
C                 =-1  DELTA SIGMA CALCULATIONS
C      NGCOND   : NUMBER OF GROUPS CONDENSED         I
C      NMERGE   : NUMBER OF REGIONS MERGED           I
C      NL       : NUMBER OF LEGENDRE ORDERS          I
C      NIFISS   : NUMBER OF FISSILE ISOTOPES         I
C      NEDMAC   : NUMBER OF EXTRA EDIT VECTORS       I
C      NTAUXT   : NUMBER OF REACTION RATE EDITS      I
C      NTENER   : NUMBER OF ENERGY GROUPS LIMITS     I
C      ENERGY   : ENERGY/LETHARGY GROUP LIMITS       R(2*NGCOND+1)
C      OLDNAM   : OLD REFERENCE DIRECTORY            C*12
C      MXVAL    : MAXIMUM DIMENSION OF OLDRAT        I
C      MXERR    : MAXIMUM DIMENSION OF VALER         I
C      VOLMER   : VOLUME OF MERGED REGIONS           D(NMERGE)
C      RATECM   : AVERAGED REGION/GROUP X-S          D(0:NMERGE,NGCOND,
C                 = RATECM(*,1) = FLUXES               NTAUXT)
C                 = RATECM(*,2) = TOTAL
C                 = RATECM(*,3) = ABS
C                 = RATECM(*,4) = FISSIONS
C                 = RATECM(*,5) = PRODUCTIONS
C                 = RATECM(*,6) = LEAKAGES
C                 = RATECM(*,7) = TOTAL OUT OF GROUP SCATTERING
C                 = RATECM(*,8) = DIAGONAL SCATTERING X-S
C                 = RATECM(*,9) = CHI
C                 = RATECM(*,10) = WIMS TYPE TRANSPORT CORRECTION
C                 = RATECM(*,11) = X-DIRECTED LEAKAGES
C                 = RATECM(*,12) = Y-DIRECTED LEAKAGES
C                 = RATECM(*,13) = Z-DIRECTED LEAKAGES
C                 = RATECM(*,*,13+JJ) NUSIGF FOR JJ
C                 = RATECM(*,*,13+NIFISS+JJ) CHI FOR JJ
C                 = RATECM(*,*,13+2*NIFISS+JJ) NFTOT FOR JJ
C                 = RATECM(*,*,13+3*NIFISS+IL) SIGS FOR IL
C                 = RATECM(*,*,13+3*NIFISS+NL+IE) EDIT IE
C                 = RATECM(*,*,NTAUXT)= 1/V MERGE CONDENSED
C      SCATTD   : NEW SCATTERING MATRIX              D(NMERGE,
C                                                      NGCOND,NGCOND,NL)
C      FLXOLD   : NEW FLUXES                         R(NMERGE)
C      OLDRAT   : OLD RATES                          R(MXVAL)
C      VALER    : DUMMY VECTOR                       R(MXERR)
C      INGSCT   : DUMMY VECTOR                       I(NMERGE)
C      IFGSCT   : DUMMY VECTOR                       I(NMERGE)
C      IPOSCT   : DUMMY VECTOR                       I(NMERGE)
C
C---------------------------   EDIDST  --------------------------------
C
      IMPLICIT          NONE
      INTEGER           IOUT,ILCMUP,ILCMDN,NSTATE
      CHARACTER         NAMSBR*6
      REAL              TRONCE
      PARAMETER        (IOUT=6,ILCMUP=1,ILCMDN=2,NSTATE=40,
     >                  TRONCE=0.001,NAMSBR='EDIDST')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER           IPEDIT,IPRINT,NSTATS,NGCOND,NMERGE,NL,NIFISS,
     >                  NEDMAC,NTAUXT,NTENER,MXVAL,MXERR
      CHARACTER         OLDNAM*12
      INTEGER           IFGSCT(NMERGE),INGSCT(NMERGE),IPOSCT(NMERGE)
      REAL              ENERGY(2*NGCOND+1),FLXOLD(NMERGE),
     >                  OLDRAT(MXVAL),VALER(MXERR)
      DOUBLE PRECISION  VOLMER(NMERGE),RATECM(0:NMERGE,NGCOND,NTAUXT),
     >                  SCATTD(NMERGE,NGCOND,NGCOND,NL)
C----
C  LOCAL PARAMETERS
C----
      CHARACTER         CGRPNM*12,CXSNAM*12,CM*2,NAMEST*20
      INTEGER           ISTATE(NSTATE),ILCMLN,ILCMTY,IGR,IREG,IFIS,
     >                  NRFISS,ILCFIS,IL,ITYPE
      REAL              ERRREL,VOLTOT,VOLT2,VOLREL,VREL1,VREL2
      DOUBLE PRECISION  SOUOLD,SOUNEW
C----
C  LOCATE REFERENCE RESULT DIRECTORY
C----
      CALL XDRSET(ISTATE,NSTATE,0)
      CALL LCMLEN(IPEDIT,OLDNAM,ILCMLN,ILCMTY)
      IF(ILCMLN .GE. 0) THEN
        WRITE(IOUT,7000) NAMSBR,OLDNAM
        CALL LCMLIB(IPEDIT)
        RETURN
      ENDIF
C----
C  CHECK ENERGY
C----
      CALL LCMSIX(IPEDIT,OLDNAM,ILCMUP)
      IF(NTENER .GT. 0) THEN
        CALL LCMLEN(IPEDIT,'ENERGY',ILCMLN,ILCMTY)
        IF(ILCMLN .EQ. NGCOND+1) THEN
          CALL LCMGET(IPEDIT,'ENERGY',OLDRAT)
          ERRREL=0.0
          DO 100 IGR=1,NGCOND+1
            ERRREL=ERRREL+ABS(ENERGY(IGR)-OLDRAT(IGR))
 100      CONTINUE
          ERRREL=ERRREL/NGCOND
          IF(ERRREL .GT. TRONCE) THEN
            WRITE(IOUT,7003) NAMSBR,ERRREL,TRONCE
            CALL LCMSIX(IPEDIT,OLDNAM,ILCMDN)
            RETURN
          ENDIF
        ELSE IF(ILCMLN .GT. 0) THEN
          WRITE(IOUT,7003) NAMSBR,ILCMLN-1,NGCOND
          CALL LCMSIX(IPEDIT,OLDNAM,ILCMDN)
          RETURN
        ENDIF
      ENDIF
C----
C  CHECK PARAMETER VECTOR
C----
      CALL LCMSIX(IPEDIT,'MACROLIB',ILCMUP)
      CALL LCMGET(IPEDIT,'STATE-VECTOR',ISTATE)
      IF(ISTATE(2) .NE. NMERGE .OR. ISTATE(1) .NE. NGCOND) THEN
        WRITE(IOUT,7001) NAMSBR,NMERGE,ISTATE(2),NGCOND,ISTATE(1)
        CALL LCMSIX(IPEDIT,'MACROLIB',ILCMDN)
        CALL LCMSIX(IPEDIT,OLDNAM,ILCMDN)
        RETURN
      ENDIF
C----
C  COMPUTE TOTAL SOURCES FOR RELATIVE FLUX NORMALIZATION
C----
      SOUOLD=0.0D0
      SOUNEW=0.0D0
      DO 110 IGR=1,NGCOND
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGCOND
        CALL LCMSIX(IPEDIT,CGRPNM,ILCMUP)
        CALL LCMGET(IPEDIT,'FLUX-INTG',FLXOLD)
        CALL LCMGET(IPEDIT,'PRODUCTION',OLDRAT)
        DO 111 IREG=1,NMERGE
          SOUOLD=SOUOLD+DBLE(FLXOLD(IREG))*DBLE(OLDRAT(IREG))
          SOUNEW=SOUNEW+RATECM(IREG,IGR,1)*RATECM(IREG,IGR,5)
 111    CONTINUE
        CALL LCMSIX(IPEDIT,CGRPNM,ILCMDN)
 110  CONTINUE
C----
C  CHECK FOR VOLUME COHERENCE
C----
      VOLTOT=0.0
      VOLT2=0.0
      CALL LCMGET(IPEDIT,'VOLUME',OLDRAT)
      DO 120 IREG=1,NMERGE
        VOLTOT=VOLTOT+VOLMER(IREG)
        VOLT2=VOLT2+OLDRAT(IREG)
 120  CONTINUE
      VOLREL=VOLT2 /VOLTOT
      DO 130 IREG=1,NMERGE
        VREL1=VOLMER(IREG)/VOLTOT
        VREL2=OLDRAT(IREG)/VOLT2
        ERRREL=ABS(VREL1-VREL2)/VREL2
        IF(ERRREL .GT. TRONCE) THEN
          WRITE(IOUT,7002) NAMSBR,VOLREL,IREG,ERRREL,TRONCE
          CALL LCMSIX(IPEDIT,'MACROLIB',ILCMDN)
          CALL LCMSIX(IPEDIT,OLDNAM,ILCMDN)
          RETURN
        ENDIF
 130  CONTINUE
      IF(SOUOLD .EQ. 0.0D0 .OR. SOUNEW .EQ. 0.0D0) THEN
        WRITE(IOUT,7004) NAMSBR
        SOUOLD=1.0D0
      ELSE
        SOUOLD=SOUOLD/SOUNEW
      ENDIF
      WRITE(IOUT,6000) NAMSBR,OLDNAM,NGCOND,NMERGE,VOLREL,SOUOLD
      DO 140 IGR=1,NGCOND
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGCOND
        CALL LCMSIX(IPEDIT,CGRPNM,ILCMUP)
        WRITE(IOUT,6001) CGRPNM
        CXSNAM='FLUX-INTG'
        CALL LCMGET(IPEDIT,CXSNAM,FLXOLD)
        IF(ABS(NSTATS) .GE. 1) THEN
          ITYPE=1
          NAMEST='  STATISTICS FOR  : '
          IF(NSTATS .NE. 2 .AND. NSTATS .NE. -1) THEN
            WRITE(IOUT,6002) NAMEST,CXSNAM
            CALL EDISTA(IPRINT,NMERGE,ITYPE,VOLMER,SOUOLD,VOLT2,
     >                  RATECM(1,IGR,1),FLXOLD,RATECM(1,IGR,2),
     >                  OLDRAT,VALER)
          ENDIF
          ITYPE=2
          IF(NSTATS .EQ. -1) THEN
            ITYPE=3
            NAMEST=' DELTA SIGMA FOR :  '
          ENDIF
          IF(NSTATS .GE. 2 .OR. NSTATS .EQ. -1) THEN
            CXSNAM='TOTAL'
            CALL LCMGET(IPEDIT,CXSNAM,OLDRAT)
            WRITE(IOUT,6002) NAMEST,CXSNAM
            CALL EDISTA(IPRINT,NMERGE,ITYPE,VOLMER,SOUOLD,VOLT2,
     >                  RATECM(1,IGR,1),FLXOLD,RATECM(1,IGR,2),
     >                  OLDRAT,VALER)
            CXSNAM='ABS'
            CALL LCMGET(IPEDIT,CXSNAM,OLDRAT)
            WRITE(IOUT,6002) NAMEST,CXSNAM
            CALL EDISTA(IPRINT,NMERGE,ITYPE,VOLMER,SOUOLD,VOLT2,
     >                  RATECM(1,IGR,1),FLXOLD,RATECM(1,IGR,3),
     >                  OLDRAT,VALER)
            CXSNAM='PRODUCTION'
            CALL LCMGET(IPEDIT,CXSNAM,OLDRAT)
            WRITE(IOUT,6002) NAMEST,CXSNAM
            CALL EDISTA(IPRINT,NMERGE,ITYPE,VOLMER,SOUOLD,VOLT2,
     >                  RATECM(1,IGR,1),FLXOLD,RATECM(1,IGR,5),
     >                  OLDRAT,VALER)
            CXSNAM='TRANC'
            CALL LCMLEN(IPEDIT,CXSNAM,ILCMLN,ILCMTY)
            IF(ILCMLN .GT. 0) THEN
              CALL LCMGET(IPEDIT,CXSNAM,OLDRAT)
              WRITE(IOUT,6002) NAMEST,CXSNAM
              CALL EDISTA(IPRINT,NMERGE,ITYPE,VOLMER,SOUOLD,VOLT2,
     >                    RATECM(1,IGR,1),FLXOLD,RATECM(1,IGR,10),
     >                    OLDRAT,VALER)
            ENDIF
            IF(NIFISS .GT. 0) THEN
              CXSNAM='NUSIGF'
              CALL LCMLEN(IPEDIT,CXSNAM,ILCMLN,ILCMTY)
              NRFISS=ILCMLN/NMERGE
              CALL LCMGET(IPEDIT,CXSNAM,VALER)
              CALL XDRSET(OLDRAT,NMERGE,0.0)
              ILCFIS=1
              DO 150 IFIS=1,NRFISS
                 DO 151 IREG=1,NMERGE
                  OLDRAT(IREG)=OLDRAT(IREG)+VALER(ILCFIS)
                  ILCFIS=ILCFIS+1
 151            CONTINUE
 150          CONTINUE
              WRITE(IOUT,6002) NAMEST,CXSNAM
              CALL EDISTA(IPRINT,NMERGE,ITYPE,VOLMER,SOUOLD,VOLT2,
     >                    RATECM(1,IGR,1),FLXOLD,RATECM(1,IGR,4),
     >                    OLDRAT,VALER)
            ENDIF
            IF(NSTATS .EQ. -1) THEN
              DO 160 IL=1,NL
                WRITE (CM,'(I2)') IL-1
                CXSNAM='SCATTERING'//CM
                CALL LCMLEN(IPEDIT,'NJJD'//CM,ILCMLN,ILCMTY)
                IF(ILCMLN .EQ. NMERGE) THEN
                  CALL LCMGET(IPEDIT,'NJJD'//CM,INGSCT)
                  CALL LCMGET(IPEDIT,'IJJD'//CM,IFGSCT)
                  CALL LCMGET(IPEDIT,'IPOD'//CM,IPOSCT)
                  CALL LCMGET(IPEDIT,'SCAD'//CM,VALER)
                  WRITE(IOUT,6002) NAMEST,CXSNAM
                  CALL EDIDEL(IPRINT,NGCOND,NMERGE,IGR,SCATTD(1,1,1,IL),
     >                        INGSCT,IFGSCT,IPOSCT,VALER,OLDRAT)
                ENDIF
 160          CONTINUE
            ELSE
              DO 170 IL=1,NL
                WRITE (CM,'(I2)') IL-1
                CXSNAM='SIGW'//CM
                CALL LCMLEN(IPEDIT,CXSNAM,ILCMLN,ILCMTY)
                IF(ILCMLN .EQ. NMERGE) THEN
                  CALL LCMGET(IPEDIT,CXSNAM,OLDRAT)
                  WRITE(IOUT,6002) NAMEST,CXSNAM
                  CALL EDISTA(IPRINT,NMERGE,ITYPE,VOLMER,SOUOLD,VOLT2,
     >                        RATECM(1,IGR,1),FLXOLD,
     >                        SCATTD(1,IGR,IGR,IL),OLDRAT,VALER)
                ENDIF
 170          CONTINUE
            ENDIF
            CXSNAM='DIFFX'
            CALL LCMLEN(IPEDIT,CXSNAM,ILCMLN,ILCMTY)
            IF(ILCMLN .GT. 0) THEN
              CALL LCMGET(IPEDIT,CXSNAM,OLDRAT)
              WRITE(IOUT,6002) NAMEST,CXSNAM
              CALL EDISTA(IPRINT,NMERGE,ITYPE,VOLMER,SOUOLD,VOLT2,
     >                    RATECM(1,IGR,1),FLXOLD,RATECM(1,IGR,11),
     >                    OLDRAT,VALER)
            ENDIF
            CXSNAM='DIFFY'
            CALL LCMLEN(IPEDIT,CXSNAM,ILCMLN,ILCMTY)
            IF(ILCMLN .GT. 0) THEN
              CALL LCMGET(IPEDIT,CXSNAM,OLDRAT)
              WRITE(IOUT,6002) NAMEST,CXSNAM
              CALL EDISTA(IPRINT,NMERGE,ITYPE,VOLMER,SOUOLD,VOLT2,
     >                    RATECM(1,IGR,1),FLXOLD,RATECM(1,IGR,12),
     >                    OLDRAT,VALER)
            ENDIF
            CXSNAM='DIFFZ'
            CALL LCMLEN(IPEDIT,CXSNAM,ILCMLN,ILCMTY)
            IF(ILCMLN .GT. 0) THEN
              CALL LCMGET(IPEDIT,CXSNAM,OLDRAT)
              WRITE(IOUT,6002) NAMEST,CXSNAM
              CALL EDISTA(IPRINT,NMERGE,ITYPE,VOLMER,SOUOLD,VOLT2,
     >                    RATECM(1,IGR,1),FLXOLD,RATECM(1,IGR,13),
     >                    OLDRAT,VALER)
            ENDIF
            CXSNAM='DIFFHOM'
            CALL LCMLEN(IPEDIT,CXSNAM,ILCMLN,ILCMTY)
            IF(ILCMLN .GT. 0) THEN
              CALL LCMGET(IPEDIT,CXSNAM,OLDRAT)
              WRITE(IOUT,6002) NAMEST,CXSNAM
              CALL EDISTA(IPRINT,NMERGE,ITYPE,VOLMER,SOUOLD,VOLT2,
     >                    RATECM(1,IGR,1),FLXOLD,RATECM(1,IGR,6),
     >                    OLDRAT,VALER)
            ENDIF
          ENDIF
        ENDIF
        CALL LCMSIX(IPEDIT,CGRPNM,ILCMDN)
 140  CONTINUE
      CALL LCMSIX(IPEDIT,'MACROLIB',ILCMDN)
      CALL LCMSIX(IPEDIT,OLDNAM,ILCMDN)
C----
C  FORMAT
C----
 7000 FORMAT(' ******  ',A6,'  WARNING ',
     >'ROUTINE  ******'/' ******  ',A12,' REFERENCE EXECUTION',
     >' DIRECTORY NOT ON LCM  ******'/'************************',
     >'**********************************************')
 7001 FORMAT(' ******  ',A6,'  WARNING ',
     >'ROUTINE  ******'/' ******  NUMBER OF REGION OR NUMBER OF ',
     >'GROUP INCONSISTENT        ******'/
     >6X,I10,' CURRENT REGIONS'/6X,I10,' OLD REGIONS'/6X,I10,' CURRENT',
     >' GROUPS'/6X,I10,' OLD GROUPS'/'************************',
     >'**********************************************')
 7002 FORMAT(' ******  ',A6,'  WARNING ',
     >'ROUTINE  ******'/' ******  RELATIVE ERROR IN VOLUME: CURRENT ',
     >'TO REFERENCE TOO LARGE ******'/
     >6X,' CURRENT VOLUME/REFERENCE VOLUME  =',1P,E12.4/
     >6X,' REGION NUMERO   =',I10/6X,' RELATIVE ERROR  =',E12.4/
     >6X,' ERROR ALLOWED   =',E12.4/'************************',
     >'**********************************************')
 7003 FORMAT(' ******  ',A6,'  WARNING ',
     >'ROUTINE  ******'/' ******  AVERAGE ABSOLUTE ERROR ON LETHARGY',
     >' WIDTH TOO LARGE      ******'/6X,' RELATIVE ERROR  =',E12.4/
     >6X,' ERROR ALLOWED   =',E12.4/'************************',
     >'**********************************************')
 7004 FORMAT(' ******  ',A6,'  WARNING ',
     >'ROUTINE  ******'/
     >       ' TOTAL NEW AND/OR OLD SOURCE IS 0.0 ',/
     >       ' RELATIVE SOURCE NORMALIZATION FACTOR SET TO 1.0',/
     >       '************************************************')
 6000 FORMAT(///1X,A6,' STATISTICS'/
     >10X,'LCM REFERENCE CASE NAME : ',A12/
     >10X,'NUMBER OF GROUPS        : ',I10/
     >10X,'NUMBER OF REGIONS       : ',I10/
     >10X,'RELATIVE VOLUMES        : ',1P,E12.4/
     >10X,'RELATIVE SOURCES        : ',1P,E12.4)
 6001 FORMAT(/' ANALYSIS OF GROUP : ',A12)
 6002 FORMAT(/A20,A12)
      RETURN
      END
