*DECK EDIENE
      SUBROUTINE EDIENE(NGROUP,NGCR  ,NGCOND,NTENER,
     >                  IGCR  ,EGCR  ,IGCOND,ENERGY,ENERV )
C
C---------------------------  EDIENE  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : EDIENE
C      USE      : EVALUATE ENERGY LIMITS FOR CONDENSATION
C      MODIFIED : 97-02-05 (G.M.)
C      AUTHOR   : G.MARLEAU
C
C  2- ROUTINE PARAMETERS:
C    INPUT/OUTPUT
C      NGROUP   : NUMBER OF GROUPS                     I
C      NGCR     : NUMBER OF COND GROUP READ ON INPUT   I
C      NGCOND   : NUMBER OF COND GROUP READ ON EDI     I
C      NTENER   : NUMBER OF ENERGY FOUND ON LIB        I
C      IGCR     : NEW GROUP LIMITS                     I(NGROUP+1)
C      EGCR     : NEW ENERGY LIMITS                    R(NGROUP+1)
C      IGCOND   : OLD GROUP LIMITS                     I(NGROUP+1)
C      ENERGY   : ENERGY/LETHARGY/AVERAGE ENERGY       R(2*NGROUP+1)
C      ENERV    : AVERAGE GROUP ENERGY                 R(NGROUP)
C
C---------------------------   EDIENE  --------------------------------
C
      IMPLICIT     NONE
      INTEGER      IOUT
      CHARACTER    NAMSBR*6
      PARAMETER   (IOUT=6,NAMSBR='EDIENE')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     NGROUP,NGCR,NGCOND,NTENER
      INTEGER     IGCR(NGROUP+1),IGCOND(NGROUP+1)
      REAL        EGCR(NGROUP+1),ENERGY(2*NGROUP+1),ENERV(NGROUP)
C----
C  LOCAL PARAMETERS
C----
      INTEGER     IGC,KDGRP,IGRP,JGRP,IGLIM
C----
C  FIND IF NEW ENERGY OR GROUP SPECIFICATIONS FROM INPUT
C----
      IF(NGCR .GT. 0) THEN
        IGC=0
        IF(EGCR(1) .NE. 0.0) THEN
          IF(NTENER .EQ. 0)  CALL XABORT(NAMSBR//
     >    ': CONDENSATION NOT PERMITTED - NO GROUP STRUCTURE')
          KDGRP=1
          DO 100 IGRP=1,NGROUP+1
            IF(EGCR(IGRP) .LT. ENERGY(NGROUP+1)) THEN
              KDGRP=NGROUP
              IGC=IGC+1
              IGCOND(IGC)=KDGRP
            ELSE IF(EGCR(IGRP) .LT. ENERGY(KDGRP)) THEN
              DO 110 JGRP=KDGRP,NGROUP
                IF(EGCR(IGRP) .GE. ENERGY(JGRP+1)) THEN
                  KDGRP=JGRP
                  IGC=IGC+1
                  IGCOND(IGC)=KDGRP
                  GO TO 115
                ENDIF
 110          CONTINUE
 115          CONTINUE
            ENDIF
            IF(KDGRP .EQ. NGROUP) GO TO 105
 100      CONTINUE
 105      CONTINUE
        ELSE
          DO 120 IGRP=1,NGROUP+1
            IGCOND(IGRP)=IGCR(IGRP)
            IF(IGCR(IGRP) .EQ. NGROUP) THEN
              IGC=IGRP
              GO TO 125
            ENDIF
 120      CONTINUE
 125      CONTINUE
        ENDIF
        NGCOND=IGC
      ENDIF
      IF(NTENER .GT. 0) THEN
C----
C  FIND ENERGY LIMITS, LETHARGY AND AVERAGE ENERGY
C----
        DO 130 IGRP=1,NGROUP
          ENERV(IGRP)=SQRT(ENERGY(IGRP)*ENERGY(IGRP+1))
 130    CONTINUE
        DO 140 IGC=1,NGCOND
          IGLIM=IGCOND(IGC)+1
          ENERGY(IGC+1)=ENERGY(IGLIM)
 140    CONTINUE
        IGLIM=NGCOND+1
        IF(ENERGY(IGLIM) .EQ. 0.0) ENERGY(IGLIM)=1.0E-5
        DO 150 IGC=1,NGCOND
          IGLIM=IGLIM+1
          ENERGY(IGLIM)=LOG(ENERGY(IGC)/ENERGY(IGC+1))
 150    CONTINUE
      ENDIF
      RETURN
      END
