*DECK EDILBD
      SUBROUTINE EDILBD(NGROUP,DLBDG,B2    )
C
C-------------------------    EDILBD    -------------------------------
C
C 1- SUBROUTINE STATISTICS:
C     NAME     : EDILBD
C     USE      : CALCULATION OF LAMBDA IN EDIT
C                LAMBDA=3*(1-ARCTG(AAA)/AAA)/ARCTG(AAA)/AAA,    B2>0
C                LAMBDA=3*((LNM/AAA)-1)/LNM/AAA            ,    B2<0
C                AAA=B/SIGTN  , LNM=0.5*LN((SIGTN+B)/(SIGTN-B))
C                FOR ABS(B/SIGTN)<CUTOFF USE SERIES EXPANSION
C     DATE     : 99-02-24
C     AUTHOR   : G. MARLEAU
C
C 2- PARAMETERS:
C    INPUT
C      NGROUP   : NUMBER OF GROUPS                   I
C      DLBDG    : TOTAL CROSS SECTION VECTOR         D(NGROUP)
C      B2       : SQUARE BUCKLING                    R
C    OUTPUT
C      DLBDG    : DOUBLE PRECISION LAMBDA            D(NGROUP)
C                 FOR SPECIFIC GROUP
C
C
C-------------------------    EDILBD    -------------------------------
C
      IMPLICIT         NONE
      INTEGER          IOUT
      CHARACTER        NAMSBR*6
      DOUBLE PRECISION DCUT
      PARAMETER       (IOUT=6,DCUT=1.0D-2,NAMSBR='EDILBD')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER          NGROUP
      REAL             B2
      DOUBLE PRECISION DLBDG(NGROUP)
C----
C  LOCAL PARAMETERS
C----
      INTEGER          IGROUP
      DOUBLE PRECISION DB,DBS,DBS2,DATG
      DO 100 IGROUP=1,NGROUP
        IF(DLBDG(IGROUP) .EQ. 0.0D0) THEN
          DLBDG(IGROUP)=1.0D0
        ELSE IF(B2 .EQ. 0.0)THEN
          DLBDG(IGROUP)=1.0D0
        ELSE IF(B2 .GT. 0.0)THEN
          DB=SQRT(B2)
          DBS=DB/DLBDG(IGROUP)
          DBS2=DBS*DBS
          IF(DBS2 .LT. DCUT) THEN
            DLBDG(IGROUP)=1.0D0-DBS2*(4.0D0/15.0D0-44.0D0*DBS2/315.0D0)
          ELSE
            DBS2=1.D0/DBS
            DATG=ATAN(DBS)
            DLBDG(IGROUP)=3.D0*DBS2*(1.-DBS2*DATG)/DATG
          ENDIF
        ELSE
          DB=SQRT(-B2)
          DBS=DB/DLBDG(IGROUP)
          DBS2=DBS*DBS
          IF(DBS2 .LT. DCUT) THEN
            DLBDG(IGROUP)=1.0D0+DBS2*(4.0D0/15.0D0+44.0D0*DBS2/315.0D0)
          ELSE
            DBS2=1.D0/DBS
            DATG=0.5D0*LOG((DLBDG(IGROUP)+DB)/(DLBDG(IGROUP)-DB))
            DLBDG(IGROUP)=3.D0*DBS2*(DBS2*DATG-1.0D0)/DATG
          ENDIF
        ENDIF
 100  CONTINUE
      RETURN
      END
