*DECK EXCELT
      SUBROUTINE EXCELT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* EXCELL TYPE (2-D) TRACKING MODULE.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_TRACK).
*  HENTRY(2) : SEQUENTIAL BINARY TRACKING FILE.
*  HENTRY(3) : OPTIONAL READ-ONLY TYPE(L_GEOM)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 04/10/94 ---
*-------------------------------------- MODIFY: R. ROY    ; 05/03/00 ---
*
      IMPLICIT   NONE
      INTEGER    NENTRY
      CHARACTER  HENTRY(*)*12
      INTEGER    IENTRY(*),JENTRY(*),KENTRY(*)
C
      INTEGER    IOUT,NSTATE
      PARAMETER (IOUT=6,NSTATE=40)
      CHARACTER  TEXT4*4,TEXT12*12,TITLE*72,HSIGN*12,CFTRAK*12
      LOGICAL    LASS,LDRASS
      DOUBLE PRECISION DFLOTT
      INTEGER    ITITL(18),ISTATE(NSTATE),KCHAR(3)
      REAL       EXTKOP(NSTATE), BASE, FLOTT, CUTOFX
C
      INTEGER    IPTRK, IPGEOM, IFTRAK,
     >           IDISP, IMPX, MAXPTS, NANIS, NORE, I, J,ISYMM,
     >           KSPEC, KTOPT, KMODL, INDIC, NITMA, IMAT,
     >           IVOL,  IIDL , LCACT,NMU
C
      COMMON     BASE(1)
*
* PARAMETER VALIDATION.
      IF(NENTRY.LT.2) CALL XABORT
     >  ('EXCELT: AT LEAST TWO DATA STRUCTURES REQUIRED')
      IF(IENTRY(1).NE.1) CALL XABORT
     >  ('EXCELT: FIRST DATA STRUCTURE NOT A LINKED LIST')
      IF(JENTRY(1).NE.0.AND.JENTRY(1).NE.1) CALL XABORT
     >  ('EXCELT: FIRST DATA STRUCTURE NOT IN CREATE OR MODIFY MODE')
      IPTRK=KENTRY(1)
*
* RECOVER GEOMETRY.
      IPGEOM=0
      DO 10 I=2,NENTRY
      IF((IENTRY(I).LE.2).AND.(JENTRY(I).EQ.2)) THEN
         CALL LCMGET(KENTRY(I),'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(J),J=1,3)
         IF(HSIGN.NE.'L_GEOM') THEN
            TEXT12=HENTRY(I)
            CALL XABORT('EXCELT: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1      '. L_GEOM EXPECTED.')
         ENDIF
         IPGEOM=KENTRY(I)
         CALL XDISET(ISTATE,NSTATE,0)
         CALL LCMGET(IPGEOM,'STATE-VECTOR',ISTATE)
         GO TO 20
      ENDIF
   10 CONTINUE
*
* RECOVER SEQUENTIAL BINARY TRACKING FILE CHARACTERISTICS.
   20 CFTRAK=' '
      IFTRAK=0
      IDISP=99
      DO 30 I=2,NENTRY
      IF(IENTRY(I).EQ.3) THEN
         CFTRAK=HENTRY(I)
         IF(JENTRY(I).EQ.0) IDISP=1
         IF(JENTRY(I).EQ.1) IDISP=-1
         IF(JENTRY(I).EQ.2) IDISP=0
         IFTRAK=KENTRY(I)
         GO TO 35
      ENDIF
   30 CONTINUE
*
   35 IMPX=1
      IF(JENTRY(1).EQ.0) THEN
        HSIGN='L_TRACK'
        READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
        CALL LCMPUT(IPTRK,'SIGNATURE',3,3,KCHAR)
        HSIGN='EXCELL'
        READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
        CALL LCMPUT(IPTRK,'TRACK-TYPE',3,3,KCHAR)
        TITLE=' '
        IF(IPGEOM.NE.0) THEN
          MAXPTS=ISTATE(6)
        ELSE
          MAXPTS=0
        ENDIF
        NANIS=1
        NORE=-2
        IF(IDISP.NE.0) NORE=0
        KSPEC=-1
        KTOPT=-1
        CUTOFX=0.0
        ISYMM=1
        LCACT=3
        NMU=0
      ELSE IF(JENTRY(1).EQ.1) THEN
        CALL LCMGET(IPTRK,'SIGNATURE',KCHAR)
        WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
        IF(HSIGN.NE.'L_TRACK') THEN
          TEXT12=HENTRY(1)
          CALL XABORT('EXCELT: SIGNATURE OF '//TEXT12//' IS '
     >    //HSIGN//' L_TRACK EXPECTED.')
        ENDIF
        CALL LCMGET(KENTRY(1),'TRACK-TYPE',KCHAR)
        WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
        IF(HSIGN.NE.'EXCELL') THEN
          TEXT12=HENTRY(1)
          CALL XABORT('EXCELT: TRACK-TYPE OF '//TEXT12//' IS '
     >    //HSIGN//'. EXCELL EXPECTED.')
        ENDIF
        CALL XDISET(ISTATE,NSTATE,0)
        CALL LCMGET(IPTRK,'STATE-VECTOR',ISTATE)
        MAXPTS=ISTATE(1)
        NANIS=ISTATE(6)
        KMODL=ISTATE(7)
        NORE=ISTATE(8)
        KTOPT=ISTATE(9)
        KSPEC=ISTATE(10)
        ISYMM=ISTATE(12)
        LCACT=ISTATE(13)
        NMU=ISTATE(14)
        CALL XDRSET(EXTKOP,NSTATE,0.0)
        CALL LCMGET(IPTRK,'EXCELTRACKOP',EXTKOP)
        CUTOFX=EXTKOP(1)
      ENDIF
   40 CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
   41 CONTINUE
      IF(INDIC.EQ.10) GO TO 50
      IF(INDIC.NE.3) CALL XABORT('EXCELT: CHARACTER DATA EXPECTED.')
      IF(TEXT4.EQ.'EDIT') THEN
         CALL REDGET(INDIC,IMPX,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('EXCELT: INTEGER DATA EXPECTED(1).')
      ELSE IF(TEXT4.EQ.'MAXR') THEN
         CALL REDGET(INDIC,MAXPTS,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('EXCELT: INTEGER DATA EXPECTED(2).')
      ELSE IF(TEXT4.EQ.'TITL') THEN
         CALL REDGET(INDIC,NITMA,FLOTT,TITLE,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('EXCELT: TITLE EXPECTED.')
      ELSE IF(TEXT4.EQ.'ANIS') THEN
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) THEN
           CALL XABORT('EXCELT: INTEGER MUST FOLLOW ANIS KEYWORD')
         ELSE
           NANIS=NITMA
           IF(NANIS.LT.1.OR.NANIS.GT.2)
     >       CALL XABORT('EXCELT: NANIS = 1 OR 2 PERMITTED ONLY')
         ENDIF
      ELSE IF(TEXT4.EQ.'RENO') THEN
         IF(IDISP.EQ.0) CALL XABORT('EXCELT: CANNOT NORMALIZE READ-ONL'
     >   //'Y BINARY TRACKING FILE')
         NORE=0
      ELSE IF(TEXT4.EQ.'RENM') THEN
         IF(IDISP.EQ.0) CALL XABORT('EXCELT: CANNOT NORMALIZE READ-ONL'
     >   //'Y BINARY TRACKING FILE')
         NORE=-1
      ELSE IF(TEXT4.EQ.'NORE') THEN
         IF(IDISP.EQ.0) CALL XABORT('EXCELT: CANNOT NORMALIZE READ-ONL'
     >   //'Y BINARY TRACKING FILE')
         NORE=1
      ELSE IF(TEXT4.EQ.'PISO') THEN
         KSPEC=0
      ELSE IF(TEXT4.EQ.'PSPC') THEN
         KSPEC=1
      ELSE IF(TEXT4.EQ.'CUT') THEN
         CALL REDGET(INDIC,NITMA, FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.2.OR.FLOTT.LT.0.0) THEN
            CALL XABORT('EXCELT: CUTOFF MUST BE A POSITIVE REAL')
         ENDIF
         CUTOFX=FLOTT
      ELSE IF(TEXT4.EQ.'GAUS') THEN
         LCACT=0
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) GO TO 41
         NMU=NITMA
      ELSE IF(TEXT4.EQ.'CACA') THEN
         LCACT=1
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) GO TO 41
         NMU=NITMA
      ELSE IF(TEXT4.EQ.'CACB') THEN
         LCACT=2
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) GO TO 41
         NMU=NITMA
      ELSE IF(TEXT4.EQ.'LCMD') THEN
         LCACT=3
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) GO TO 41
         NMU=NITMA
      ELSE IF(TEXT4.EQ.'TRAK') THEN
         IF(IDISP.LE.0) CALL XABORT('EXCELT: TRAK KEYWORD NOT REQUIRED')
         GO TO 50
      ELSE IF(TEXT4.EQ.';') THEN
         IF(IDISP.GT.0) CALL XABORT('EXCELT: TRAK KEYWORD EXPECTED')
         GO TO 50
      ELSE
         CALL XABORT('EXCELT: '//TEXT4//' IS AN INVALID KEY WORD.')
      ENDIF
      GO TO 40
*
* CHECK GEOMETRY CONSISTENCY.
   50 IF(IPGEOM.NE.0) LASS=LDRASS(IPGEOM,1,IMPX)
*
      READ(TITLE,'(18A4)') (ITITL(I),I=1,18)
      CALL LCMPUT(IPTRK,'TITLE',18,3,ITITL)
      IF(IMPX.GT.1) WRITE(IOUT,'(1X,A72//)') TITLE
*
      IF(MAXPTS.EQ.0) CALL XABORT('EXCELT: MAXPTS NOT DEFINED.')
      CALL SETARA(BASE,MAXPTS,IMAT)
      CALL SETARA(BASE,MAXPTS,IVOL)
      CALL SETARA(BASE,MAXPTS,IIDL)
      CALL XELDRV(IPTRK ,IPGEOM,IMPX  ,MAXPTS,NANIS ,NORE  ,
     >            KSPEC ,KTOPT ,TITLE ,CUTOFX,CFTRAK,IFTRAK,
     >            IDISP ,ISYMM ,LCACT ,NMU   ,
     >            BASE(IMAT)   ,BASE(IVOL)   ,BASE(IIDL)   )
      CALL RLSARA(BASE(IIDL))
      CALL RLSARA(BASE(IVOL))
      CALL RLSARA(BASE(IMAT))
*
      RETURN
      END
