*DECK GXSGET
      SUBROUTINE GXSGET(IPMACR,IUGOXS,NBMIX ,NGROUP,NANISO,NBELEM,
     >                  NEXTMI,NEXTRE,NFILCN,IFILCN,KEXS  ,KMXS  ,
     >                  KINS  ,KXSS  ,
     >                  IPERMU,XSTOTL,XSTRAN,XSFISS,XSSCAT,XSWORK,
     >                  IEDXS ,XSPRIN,INDSCT,XSSMAT)
C
C---------------------------  GXSGET  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : GXSGET
C       USE      : READ CROSS SECTIONS ON GOXS.
C                  MAIN XS STORED IN VECTOR
C                  ADD XS STORED ON THE MACROLIB
C       MODIFIED : 91-01-24
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C    INPUT
C       IPMACR   : POINTER TO THE MACROLIB            I
C       IUGOXS   : UNIT FOR GOXS                      I
C       NBMIX    : NUMBER OF MIXTURES                 I
C       NGROUP   : NUMBER OF ENERGY GROUPS            I
C       NANISO   : MAXIMUM LEGENDRE ORDER             I
C                  = 1 ISOTROPIC COLLISION
C                  = 2 LINEARLY ANISOTROPIC COLLISION
C       NBELEM   : NB OF MIXTURE IF ANY TO PERMUTE    I
C       NEXTMI   : NEXT MIXTURE TO READ               I
C       NEXTRE   : NEXT RECORD TO READ                I
C       NFILCN   : DIMENSION IFILCN VECTOR            I
C       IFILCN   : GOXS FILE INTEGER DATA             I(NFILCN)
C       KEXS     : DIMENSION OF IEDXS VECTOR          I
C       KMXS     : DIMENSION OF XSPRIN VECTOR         I
C       KINS     : DIMENSION OF INDSCT VECTOR         I
C       KXSS     : DIMENSION OF XSSMAT VECTOR         I
C       IPERMU   : PERMUTATION VECTOR                 I(NBMIX)
C       XSTOTL   : TOTAL CROSS SECTION OF MIXTURE     R(NBMIX,NGROUP)
C       XSTRAN   : TRANSPORT CORRECTION XS OF MIXTURE R(NBMIX,NGROUP)
C       XSFISS   : FISSION CROSS SECTION OF MIXTURE   R(NBMIX,
C                                                       NGROUP,3)
C       XSSCAT   : SCATT X-SECTION OF MIXTURE/GROUP   R(NBMIX,NANISO,
C       XSWORK   : WORK CROSS-SECTION VECTOR          R(NBMIX)
C       IEDXS    : POSITION OF PRIMARY XS             I(KEXS)
C       XSPRIN   : MAIN CROSS-SECTIONS                R(KMXS)
C       INDSCT   : SCATTERING X-S INDICATORS          I(KINS)
C       XSSMAT   : SCATTERING X-S MATRIX              R(KXSS)
C
C---------------------------   GXSGET  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,ILCMUP,ILCMDN,MAXED,NBXG
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,ILCMUP=1,ILCMDN=2,MAXED=50,NBXG=7,
     >            NAMSBR='GXSGET')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPMACR,IUGOXS,NBMIX,NGROUP,NANISO,NBELEM,NEXTMI,
     >            NEXTRE,NFILCN,KEXS,KMXS,KINS,KXSS
      INTEGER     IFILCN(NFILCN),IPERMU(NBMIX),IEDXS(KEXS),
     >            INDSCT(KINS)
      REAL        XSTOTL(NBMIX,NGROUP),XSTRAN(NBMIX,NGROUP),
     >            XSFISS(NBMIX,NGROUP,3),
     >            XSSCAT(NGROUP,NBMIX,NANISO,NGROUP),
     >            XSWORK(NBMIX),XSPRIN(KMXS),XSSMAT(KXSS)
C----
C  MEMORY ALLOCATION
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     INAM,IADNAM
C----
C  LOCAL PARAMETERS
C----
      INTEGER     ITXS(NBXG),MULTA6,KSETPE,KNAM,MILIEU,NORDLE,
     >            NEDGXS,IDPREC,NPRIXS,NXST,NSMIL,JMIL,ISMIL,NNMIL,
     >            J,NADDXS,JADN,JJ,JJJJ,IMIL,IGROUP,IDBRL,JSMIL,
     >            IMILT,IMILN,IMILF,IMILS,IMILC,IMILZ,NSKPXS,IEDTXS,
     >            ILCMLN,ILCMTY,MATNUM,NBXGS,INB,IPOSS,IPOSN,IPOSL,
     >            NGT,IORD,LSTG,NGS,IG,MIPOS
      CHARACTER   CGRPNM*12,CMATN(10)*12,FMTRD*5,HVECT(MAXED)*8
      REAL        FCTLP1
C----
C  DATA
C----
      CHARACTER   CEDNAM(NBXG)*12
      SAVE        CEDNAM
      DATA       (CEDNAM(IEDTXS),IEDTXS=1,NBXG)
     >           /'TOTAL       ','ABS         ','NUSIGF      ',
     >            'CHI         ','            ','TRANC       ',
     >            'NFTOT       '/
C----
C  INITIALISE GOXS LIBRARY CONSTANTS
C----
      CALL GXSDIM(MULTA6,FMTRD)
      KSETPE=IFILCN(9)+IFILCN(4)
      KNAM=(IFILCN(2)+KSETPE)*MULTA6+2*NGROUP+1
      CALL SETARA(IBASE,KNAM,INAM)
      CALL XDREED(IUGOXS,NEXTRE,IBASE(INAM),KNAM)
      NEXTRE=NEXTRE+1
      MILIEU=IFILCN(2)
      NORDLE=IFILCN(3)
      NEDGXS=IFILCN(4)
      IDPREC=IFILCN(5)
      NPRIXS=IFILCN(9)
      NXST=MILIEU*(NEDGXS+NPRIXS)
      CALL SETARA(IBASE,2*MAX(NEDGXS+NPRIXS,1),IADNAM)
C----
C  PRINT MATERIAL NAMES
C----
      NSMIL=(MILIEU-1)/10
      JMIL=INAM
      WRITE(IOUT,6000)
      DO 80 ISMIL=0,NSMIL
        NNMIL=MIN(10,MILIEU-ISMIL*10)
        DO 81 JSMIL=1,NNMIL
          CMATN(JSMIL)='            '
          WRITE(CMATN(JSMIL),FMTRD)
     >      (IBASE(J),J=JMIL,JMIL+MULTA6-1)
          JMIL=JMIL+MULTA6
 81     CONTINUE
        WRITE(IOUT,6001) (CMATN(J),J=1,NNMIL)
 80   CONTINUE
C----
C  LOCATE POSITION OF PRIMARY AND ADDITIONAL XS CROSS SECTIONS
C----
      DO 89 IEDTXS=1,NBXG
        ITXS(IEDTXS)=0
 89   CONTINUE
      NADDXS=0
      JADN=IADNAM
      DO 90 J=1,NPRIXS+NEDGXS
        WRITE(CMATN(1),FMTRD) (IBASE(JJ),JJ=JMIL,JMIL+MULTA6-1)
        HVECT(J)=CMATN(1)
        IEDXS(J)=0
        DO 91 IEDTXS=1,NBXG
          IF(CMATN(1) .EQ. CEDNAM(IEDTXS)) THEN
            ITXS(IEDTXS)=(J-1)*MILIEU+1
            IEDXS(J)=IEDTXS
            GO TO 95
          ENDIF
 91     CONTINUE
        NADDXS=NADDXS+1
        DO 92 JJJJ=0,1
          IBASE(JADN+JJJJ)=IBASE(JMIL+JJJJ)
 92     CONTINUE
        JADN=JADN+2
 95     CONTINUE
        JMIL=JMIL+MULTA6
 90   CONTINUE
      IF(NBELEM .EQ. 0) THEN
        DO 100 IMIL=1,MILIEU
          IPERMU(IMIL)=NEXTMI
          NEXTMI=NEXTMI+1
 100    CONTINUE
        NBELEM=MILIEU
      ENDIF
      DO 110 IGROUP=1,NGROUP
C----
C  READ EDIT X-S
C----
        CALL XDREED(IUGOXS,NEXTRE,XSPRIN,NXST*IDPREC)
        NEXTRE=NEXTRE+1
        IF(IDPREC .EQ. 2) THEN
C----
C  TRANSFER DOUBLE PRECISION X-S TO SINGLE PRECISION
C----
          IDBRL=1
          CALL XDRSDB(NXST,XSPRIN,XSPRIN,IDBRL)
        ENDIF
C----
C  TRANSFER XSPRIN INSIDE ADEQUATE X-S VECTOR
C----
        IMILT=ITXS(1)
        IMILN=ITXS(3)
        IMILS=ITXS(4)
        IMILC=ITXS(6)
        IMILF=ITXS(7)
        DO 120 IMILZ=1,NBELEM
          MATNUM=IPERMU(IMILZ)
          IF(MATNUM .GT. 0) THEN
            IF(ITXS(1) .GT. 0) XSTOTL(MATNUM,IGROUP)=XSPRIN(IMILT)
            IF(ITXS(3) .GT. 0) XSFISS(MATNUM,IGROUP,1)=XSPRIN(IMILN)
            IF(ITXS(4) .GT. 0) XSFISS(MATNUM,IGROUP,3)=XSPRIN(IMILS)
            IF(ITXS(6) .GT. 0) XSTRAN(MATNUM,IGROUP)=XSPRIN(IMILC)
            IF(ITXS(7) .GT. 0) XSFISS(MATNUM,IGROUP,2)=XSPRIN(IMILF)
          ENDIF
          IMILT=IMILT+1
          IMILN=IMILN+1
          IMILS=IMILS+1
          IMILC=IMILC+1
          IMILF=IMILF+1
 120    CONTINUE
        IF(NADDXS .GT. 0) THEN
C----
C  READ ADDITIONAL XS AND STORE DIRECTLY ON THE MACROLIB
C----
          CALL LCMPUT(IPMACR,'ADDXSNAME',2*NADDXS,3,IBASE(IADNAM))
          WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGROUP,NGROUP
          CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
          MIPOS=0
          NSKPXS=MILIEU-NBELEM
          DO 130 IEDTXS=1,NEDGXS+NPRIXS
            IF(IEDXS(IEDTXS) .EQ. 0) THEN
              CALL LCMLEN(IPMACR,HVECT(IEDTXS),ILCMLN,ILCMTY)
              CALL XDRSET(XSWORK,NBMIX,0.0)
              IF(ILCMLN .GT. 0) THEN
                CALL LCMGET(IPMACR,HVECT(IEDTXS),XSWORK)
              ENDIF
              DO 150 IMIL=1,NBELEM
                MIPOS=MIPOS+1
                MATNUM=IPERMU(IMIL)
                IF(MATNUM .GT. 0) THEN
                  XSWORK(MATNUM)=XSPRIN(MIPOS)
                ENDIF
 150          CONTINUE
              MIPOS=MIPOS+NSKPXS
              CALL LCMPUT(IPMACR,HVECT(IEDTXS),NBMIX,2,XSWORK)
            ELSE
              MIPOS=MIPOS+MILIEU
            ENDIF
 130      CONTINUE
          CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
        ENDIF
        IF(NORDLE .GT. 0) THEN
C----
C  READ SCATTERING CONTROL
C----
          CALL XDREED(IUGOXS,NEXTRE,INDSCT,2*NORDLE*MILIEU)
          NEXTRE=NEXTRE+1
          NBXGS=0
          DO 160 INB=1,NORDLE*MILIEU
            NBXGS=NBXGS+INDSCT(INB)
 160      CONTINUE
C----
C  READ SCATTERING MATRIX
C----
          CALL XDREED(IUGOXS,NEXTRE,XSSMAT,NBXGS*IDPREC)
          NEXTRE=NEXTRE+1
          IF(IDPREC .EQ. 2) THEN
C----
C  GET SIMPLE PRECISION SCATTERING XS
C----
            IDBRL=1
            CALL XDRSDB(NBXGS,XSSMAT,XSSMAT,IDBRL)
          ENDIF
C----
C  FORM COMPLETE SCATTERING MATRIX XSSCAT(IG,IPERMU(IMIL),IORD,IGROUP)
C  WHERE IG IS THE PRIMARY AND IGROUP THE SECONDARY GROUP
C  AND REMOVE FACTOR (2L+1)=(2*IORD-1) FROM SCATTERING X-S.
C----
          IPOSS=0
          IPOSN=0
          IPOSL=NORDLE*MILIEU
          DO 180 IMIL=1,NBELEM
            MATNUM=IPERMU(IMIL)
            IF(MATNUM .EQ. 0) THEN
C----
C  MATERIAL NOT INCLUDED ON THE MACROLIB, LOCATE NEXT MATERIAL IN XSSMAT
C----
              IPOSL=IPOSL+NORDLE
              NGT=0
              DO 190 IORD=1,NORDLE
                IPOSN=IPOSN+1
                NGT=NGT+INDSCT(IPOSN)
 190          CONTINUE
              IPOSS=IPOSS+NGT
            ELSE
              DO 200 IORD=1,NORDLE
                IPOSN=IPOSN+1
                IPOSL=IPOSL+1
                NGS=INDSCT(IPOSN)
                LSTG=INDSCT(IPOSL)
                IF(IORD .GT. 1) THEN
                  FCTLP1=1.0/FLOAT(2*IORD-1)
                  DO 205 IG=NGROUP,1,-1
                    IF(IG .GT. LSTG .OR. IG .LE. (LSTG-NGS)) THEN
                      XSSCAT(IG,MATNUM,IORD,IGROUP)=0.0
                    ELSE
                      IPOSS=IPOSS+1
                      XSSCAT(IG,MATNUM,IORD,IGROUP)=XSSMAT(IPOSS)*
     >                                              FCTLP1
                    ENDIF
 205              CONTINUE
                ELSE
                  DO 210 IG=NGROUP,1,-1
                    IF(IG .GT. LSTG .OR. IG .LE. (LSTG-NGS)) THEN
                      XSSCAT(IG,MATNUM,IORD,IGROUP)=0.0
                    ELSE
                      IPOSS=IPOSS+1
                      XSSCAT(IG,MATNUM,IORD,IGROUP)=XSSMAT(IPOSS)
                    ENDIF
 210              CONTINUE
                ENDIF
 200          CONTINUE
            ENDIF
 180      CONTINUE
        ENDIF
 110  CONTINUE
      CALL RLSARA(IBASE(IADNAM))
      CALL RLSARA(IBASE(INAM))
      RETURN
C----
C  FORMAT
C----
 6000 FORMAT(' NAMES OF MATERIALS READ ON GOXS:')
 6001 FORMAT(1X,10A12)
      END
