*DECK MCI2BL
      SUBROUTINE MCI2BL( NG, NS, NR, FLUX, SOUR, SOURG, VOL, MASQ, 
     >                   MATALB, ALBEDO, 
     >                   MATCOD, NM, NA, XSTOT, XSCAT, XSDIA, 
     >                   XSTRC , REBAL, IPRT)
C
      IMPLICIT  NONE
      INTEGER   NR, NS, NG, NA, NM, IPRT, MASQ(NG), IG, JG, IR
      INTEGER   MATCOD(NR), NGUNC, NSOUR, IGUNC, JGUNC, IER
      INTEGER   MATALB(-NS:NR)
      REAL      VOL(NR),DZERO
      REAL      XSTOT(0:NM,NG),
     >          XSCAT(NG,0:NM,0:NA,NG),
     >          XSDIA(NG,0:NM,0:NA)
      REAL      REBAL(NG,NG+1),ALBEDO(6)
      DOUBLE PRECISION 
     >          FLUX(NG,-NS:NR),
     >          SOUR(NG,NR),
     >          SOURG(NG,NR)
      PARAMETER ( DZERO=0.0 )
      REAL       XSTRC(0:NM,NG)
C
      NGUNC= 0
      DO  3 IG=1,NG
         IF( MASQ(IG).EQ.0 )THEN
            NGUNC= NGUNC+1
            DO  1 JG=1,NG+1 
               REBAL(NGUNC,JG)= DZERO
    1       CONTINUE
C
C           CHARGE TOTAL REACTION RATES
            DO  20 IR=-NS,-1
               REBAL(NGUNC,NGUNC)= REBAL(NGUNC,NGUNC)+
     >               FLUX(IG,IR)*(1.-ALBEDO(-MATALB(IR)))
   20       CONTINUE
C
C           CHARGE TOTAL REACTION RATES
            DO  2 IR=1,NR
               REBAL(NGUNC,NGUNC)= REBAL(NGUNC,NGUNC)+
     >           XSTOT(MATCOD(IR),IG)*FLUX(IG,IR)*VOL(IR)
    2       CONTINUE
         ENDIF
    3 CONTINUE
      NSOUR= NGUNC+1
      IGUNC= 0
      DO  8 IG=1,NG
         IF( MASQ(IG).EQ.0 )THEN
            IGUNC= IGUNC+1
C
C           CHARGE FISSION SOURCES
            DO  4 IR=1,NR
               REBAL(IGUNC,NSOUR)= REBAL(IGUNC,NSOUR)+
     >           SOUR(IG,IR)*VOL(IR)
    4       CONTINUE
            JGUNC= 0
            DO  7 JG= 1, NG
               IF( MASQ(JG).EQ.0 )THEN
                  JGUNC= JGUNC+1
                  IF( IG.EQ.JG )THEN
                    DO 55 IR=1,NR
                      REBAL(IGUNC,JGUNC)= REBAL(IGUNC,JGUNC)-
     >                  XSDIA(JG,MATCOD(IR),0)*FLUX(JG,IR)*VOL(IR)
   55               CONTINUE
                  ELSE
                    DO  5 IR=1,NR
                      REBAL(IGUNC,JGUNC)= REBAL(IGUNC,JGUNC)-
     >                  XSCAT(JG,MATCOD(IR),0,IG)*FLUX(JG,IR)*VOL(IR)
    5               CONTINUE
                  ENDIF
               ELSE
                  IF( IG.EQ.JG )THEN
                    DO 66 IR=1,NR
                      REBAL(IGUNC,NSOUR)= REBAL(IGUNC,NSOUR)+
     >                  XSDIA(JG,MATCOD(IR),0)*FLUX(JG,IR)*VOL(IR)
   66               CONTINUE
                  ELSE
                    DO  6 IR=1,NR
                      REBAL(IGUNC,NSOUR)= REBAL(IGUNC,NSOUR)+
     >                  XSCAT(JG,MATCOD(IR),0,IG)*FLUX(JG,IR)*VOL(IR)
    6               CONTINUE
                  ENDIF
               ENDIF
    7       CONTINUE
         ENDIF
    8 CONTINUE
      IF( IPRT.GT.10000 )THEN
         DO 32 IGUNC= 1, NGUNC
           WRITE(6,1000) (REBAL(IGUNC,JGUNC),JGUNC=1,NGUNC+1)
   32    CONTINUE
      ENDIF
      CALL ALSB(NGUNC,1,REBAL,IER,NG)
      IF( IER.NE.0 ) CALL XABORT(' MCI2BL: SINGULAR REBALANCING MATRIX')
C
C     REBALANCE FLUXES
      IGUNC= 0
      DO 13 IG=1,NG
         IF( MASQ(IG).EQ.0 )THEN
            IGUNC= IGUNC+1
            DO 11 IR=-NS,-1
               FLUX(IG,IR)= FLUX(IG,IR) * REBAL(IGUNC,NSOUR)
   11       CONTINUE
            DO 12 IR=1,NR
               FLUX(IG,IR)= REBAL(IGUNC,NSOUR)*FLUX(IG,IR)
   12       CONTINUE
            IF( IPRT.GT.1000 )THEN
               WRITE(6,*)'REBAL(',IG,')=',REBAL(IGUNC,NSOUR)
            ENDIF
         ENDIF
   13 CONTINUE
      IF( IPRT.GT.5 )THEN
         WRITE(6,1040)(REBAL(IGUNC,NSOUR),IGUNC=1,NGUNC)
      ENDIF
      RETURN
 1040 FORMAT (7H REBA  ,2H: ,1P,10E12.5/(9X,10E12.5))
 1000 FORMAT(1X,1P,10(E15.6,2X))
      END
