*DECK MOC
      SUBROUTINE MOC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*PARAMETERS: WORKING 
*  NREGIO : NO. OF REGIONS                                      I
*  NUN    : VARIABLE HAVING VALUE EQUAL TO NREGIO               I  
*  NGRP   : NO. OF ENERGY GROUP                                 I
*  ISADJ  : FLAG FOR TYPE OF ADJOINT CALCULATION                I
*    ISADJ = 1 ADJOINT FLUX CALCULATION WITHOUT EXTERNAL
*              SOURCE
*    ISADJ = 2 ADJOINT FLUX CALCULATION WITH EXTERNAL SOURCE
*  IAJFLO : INDEX POINTER FOR GLOBAL ADJOINT FLUX VECTOR        I
*  CADJFL : STRING CONTAINING THE NAME OF ADJOINT FLUX          C(2)*8
*           DIRECTORY IN IPFLUX DATA STRUCTURE
*  CADJFL(1) FOR SOURCE IMPORTANCE(INTEGRO-DIFF TRANSPORT ADJOINT FLUX)
*  CADJFL(2) FOR FLUX IMPORTANCE(INTEGRAL TRANSPORT ADJOINT FLUX)
*
*  LDRFLX : CONTROL FLAG FOR DIRECT FLUX CALCULATION            L
*           [ .TRUE. : ENABLE DIRECT FLUX CAL. ]
*           [ .FALSE.: DISABLE DIRECT FLUX CAL.]
*  LDAJCB : CONTROL FLAG FOR DIRECT & ADJOINT FLUX              L
*           COMBINED CALCULATION
*
*
*
*
*------------------- AUTHOR: R. ROY ; 22/01/96 --------------------------------
*
      IMPLICIT    NONE
      INTEGER     IOUT,NSTATE
      PARAMETER ( IOUT=6,NSTATE=40)
      INTEGER     NWORDS
      PARAMETER ( NWORDS=1 )
      REAL        EPSX(3),AIEPS,AEEPS
      INTEGER     NENTRY,IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
      CHARACTER   HENTRY(NENTRY)*12,HSIGN*12,TEXT12*12,HSMG*131,
     >            TITRE*72,CDIRFL*12
      LOGICAL     LEAKSW,ILK,LEXIN 
      INTEGER     LCACA
      INTEGER     KCHAR(18),ISTATE(NSTATE)
      INTEGER     IPFLUX,IPMACR,IPTRK,IFTRAK,ITYLCM,ILNLCM
      INTEGER     NJJ,IFLUXO,IFRITR,ILEAK,IACITR,IREBAL,IJJ,MAXM1,
     >            IPOS,ITYPEC,IGP4,I1,NUN,NREG,IREG,NGRP,ITRB,NL,NBN,
     >            NEXTMX,NINTMX,IPRT,NANIS,MAXMIX,NIFIS,ITRANC,NALB
      INTEGER     IKSYS,IKTRK,IKMACR,IKTRAK,IPSYS,IFTRK2,IKFTK2,
     >            IPTMP,IPEDIT,IEN,ITC,IAJFLO, ISADJ,IPTRK2,IKTRK2,
     >            NCOMNT,NTRK2,NTRK,DUMMY
      REAL        RKEFF
      CHARACTER   CADJFL(2)*12,NAMSBR*6,CINI*4
      PARAMETER   (NAMSBR='MOC   ' )
      LOGICAL      LDRFLX,LDAJCB,LMODE(20)
      INTEGER  KTOPT2,NANGL2,ISYMM2,LCACT2,NMU2,NGSS2
      INTEGER     MATCOD,KEYFLX,VOL,VOLINV,XSNUF,XSCHI,VSCAT,XSCAT,
     >            XSOLD,XSSIGT,XSSIGW,XTINV,XSTK,DIFFB1,ALBEDO,FLUX
      DOUBLE PRECISION REFKEF, DONE
      INTEGER     LCACT,NMU,ISYMM,NGSS,NANGL,KTOPT
      PARAMETER ( DONE=1.0D0 )
      INTEGER     I(1)
      REAL        A
      COMMON      A(1)
      EQUIVALENCE (A(1),I(1))
      REAL        ZERO, ONE
      PARAMETER ( ZERO=0., ONE=1. )
      CDIRFL   ='FLUXDIRECT  '
      CADJFL(1)='FLUXADJOINT '
      CADJFL(2)='FLUXADJ     '
      AIEPS = 5.0E-05
      AEEPS = 1.0E-05
      IF(NENTRY .LT. 4) CALL XABORT(NAMSBR//
     >  ': AT LEAST FOUR DATA STRUCTURES REQUIRED')
      IF(IENTRY(1) .NE. 1 .AND. IENTRY(1) .NE. 2) CALL XABORT(NAMSBR//
     >  ': FIRST DATA STRUCTURE NOT A LINKED LIST OR XSM FILE')
      IPFLUX=KENTRY(1)
      IF(JENTRY(1) .EQ. 0) THEN
        HSIGN='L_FLUX'
        READ(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,3)
        CALL LCMPUT(IPFLUX,'SIGNATURE',3,3,KCHAR)
      ELSE IF(JENTRY(1) .EQ. 1) THEN
        CALL LCMGET(IPFLUX,'SIGNATURE',KCHAR)
        WRITE(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,3)
        IF(HSIGN .NE. 'L_FLUX') THEN
          CALL XABORT(NAMSBR//
     >      ': SIGNATURE OF '//HENTRY(1)//' IS '//HSIGN//
     >      '. L_FLUX EXPECTED.')
        ENDIF
      ELSE
        CALL XABORT(NAMSBR//
     >    ': FLUX STRUCTURE IN READ-ONLY MODE FORBIDDEN')
      ENDIF
      IPTRK2 = 0
      IKTRK2 = 0
      IKFTK2 = 0
      IFTRK2=0
      IKSYS=0
      IKTRK=0
      IKMACR=0
      IKTRAK=0
      IPSYS=0
      IPTRK=0
      IPMACR=0
      IFTRAK=0
      DO 100 IEN=2,NENTRY
        TEXT12=HENTRY(IEN)
        IF(JENTRY(IEN) .NE. 2) CALL XABORT(NAMSBR//
     >    ': DATA STRUCTURE '//TEXT12//' NOT IN READ-ONLY MODE')
        IF(IENTRY(IEN) .EQ. 1 .OR. IENTRY(IEN) .EQ. 2) THEN
          CALL LCMGET(KENTRY(IEN),'SIGNATURE',KCHAR)
          WRITE(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,3)
          IF(HSIGN .EQ. 'L_PIJ' .AND. IKSYS .EQ. 0) THEN
            IPSYS=KENTRY(IEN)
            IKSYS=IEN
          ELSE IF(HSIGN .EQ. 'L_TRACK' .AND. IKTRK .EQ. 0) THEN
            IPTRK=KENTRY(IEN)
            IKTRK=IEN
          ELSE IF(HSIGN .EQ. 'L_TRACK' .AND. IKTRK2 .EQ. 0) THEN
            IPTRK2=KENTRY(IEN)
            IKTRK2=IEN
          ELSE IF(HSIGN .EQ. 'L_LIBRARY' .AND. IKMACR .EQ. 0) THEN
            IPMACR=KENTRY(IEN)
            IKMACR=IEN
          ELSE IF(HSIGN .EQ. 'L_MACROLIB' .AND. IKMACR .EQ. 0) THEN
            IPMACR=KENTRY(IEN)
            IKMACR=-IEN
          ENDIF
        ELSE IF(IENTRY(IEN) .EQ. 3 .AND. IKTRAK .EQ. 0) THEN
          IFTRAK=KENTRY(IEN)
          IKTRAK=IEN
        ELSE IF(IENTRY(IEN) .EQ. 3 .AND. IKFTK2 .EQ. 0) THEN
          IFTRK2=KENTRY(IEN)
          IKFTK2=IEN
        ENDIF
 100  CONTINUE
      IF(IKTRK .EQ. 0) CALL XABORT(NAMSBR//
     >  ': NO DATA STRUCTURE WITH SIGNATURE L_TRACK FOUND.')
      IF(IKMACR .EQ. 0) CALL XABORT(NAMSBR//
     >  ': NO DATA STRUCTURE WITH SIGNATURE '//
     >   'L_LIBRARY OR L_MACROLIB FOUND.')
      REWIND IFTRAK
      READ(IFTRAK) CINI,NCOMNT,NTRK
      NTRK2 = 0
      IF (IFTRK2 .GT. 0) THEN
       REWIND IFTRK2
       READ(IFTRK2) CINI,NCOMNT,NTRK2
      ENDIF
      IF (NTRK2 .GT. NTRK ) THEN
       DUMMY  = IPTRK
       IPTRK  = IPTRK2
       IPTRK2 = DUMMY
       DUMMY  = IKTRK
       IKTRK  = IKTRK2
       IKTRK2 = DUMMY
       DUMMY  = IKTRAK
       IKTRAK = IKFTK2
       IKFTK2 = DUMMY
       DUMMY  = IFTRAK
       IFTRAK = IFTRK2
       IFTRK2 = DUMMY
      ENDIF
      IF(IPTRK2.GT.0)   THEN
        CALL XDISET(ISTATE,NSTATE,0)
        CALL LCMGET(IPTRK2,'STATE-VECTOR',ISTATE)
        KTOPT2=  ISTATE(9)
        NANGL2=  ISTATE(11)
        ISYMM2=  ISTATE(12)
        LCACT2=  ISTATE(13)
        NMU2  =  ISTATE(14)
      ENDIF
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPTRK,'STATE-VECTOR',ISTATE)
      NREG  = ISTATE(1)
      NUN   = ISTATE(2)
      LEAKSW= ISTATE(3).EQ.0
      IGP4  = ISTATE(4)
      KTOPT = ISTATE(9)
      NANGL = ISTATE(11)
      ISYMM = ISTATE(12)
      LCACT = ISTATE(13)
      NMU   = ISTATE(14)
      IF(IPTRK2 .EQ. 0)   THEN
        KTOPT2=  0
        NANGL2=  NANGL
        ISYMM2=  ISYMM
        LCACT2=  LCACT
        NMU2  =  NMU
      ENDIF
      NALB=   6
      CALL SETARA( I, NREG, MATCOD )
      CALL SETARA( A, NREG, VOL    )
      CALL SETARA( A, NREG, VOLINV )
      CALL SETARA( I, NREG, KEYFLX )
      CALL SETARA( A, NALB, ALBEDO )
      CALL LCMLEN(IPTRK,'MATCOD',ILNLCM,ITYLCM)
      IF( ILNLCM.NE.NREG )THEN
         CALL XABORT( 'MOC: INCOMPATIBLE NUMBER OF REGIONS')
      ENDIF
      CALL LCMGET(IPTRK,'MATCOD',I(MATCOD))
      CALL LCMGET(IPTRK,'VOLUME',A(VOL))
      DO 1000 IREG=1,NREG
         A(VOLINV+IREG-1)= ONE/A(VOL+IREG-1)
           IF(A(VOL+IREG-1).EQ. 0.0)  THEN
            CALL XABORT( 'MOC: VOL=0')
           ENDIF
 1000 CONTINUE
      CALL LCMGET(IPTRK,'KEYFLX',I(KEYFLX))
      CALL LCMLEN(IPTRK,'ALBEDO',ILNLCM,ITYLCM)
      IF( ILNLCM.NE.NALB )THEN
         CALL XABORT( 'MOC: INCOMPATIBLE NUMBER OF ALBEDOS')
      ENDIF
      CALL LCMGET(IPTRK,'ALBEDO',A(ALBEDO))
      CALL LCMLEN(IPTRK,'TITLE',ILNLCM,ITYLCM)
      IF( ILNLCM.GT.0 )THEN
         CALL LCMGET(IPTRK,'TITLE',KCHAR)
         WRITE(TITRE,'(18A4)') (KCHAR(I1),I1=1,18)
      ELSE
         TITRE='*** NO TITLE PROVIDED ***'
      ENDIF
      CALL LCMGET(IPMACR,'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      IF(HSIGN.EQ.'L_LIBRARY') THEN
         CALL LCMSIX(IPMACR,'MACROLIB',1)
      ELSE IF(HSIGN.NE.'L_MACROLIB') THEN
         TEXT12=HENTRY(2)
         CALL XABORT('MOC: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_MACROLIB EXPECTED.')
      ENDIF
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPMACR,'STATE-VECTOR',ISTATE)
      NGRP=   ISTATE(1)
      MAXMIX= ISTATE(2)
      NANIS=  ISTATE(3)-1
      NIFIS=  MAX(ISTATE(4),1)
      ITRANC= ISTATE(6)
      IF(IGP4.GT.MAXMIX) THEN
         WRITE(HSMG,'(45HMOC: THE NUMBER OF MIXTURES IN THE TRACKING (,
     1   I5,55H) IS GREATER THAN THE NUMBER OF MIXTURES IN THE MACROLI,
     2   3HB (,I5,2H).)') IGP4,MAXMIX
         CALL XABORT(HSMG)
      ENDIF
      IPRT= 1
      ITRB= 0
      NL=  -1
      NBN= -1
      IF( JENTRY(1).EQ.1 )THEN
         CALL LCMLEN(IPFLUX,'STATE-VECTOR',ILNLCM,ITYLCM)
         IF( ILNLCM.EQ.0.OR.ITYLCM.NE.1 )THEN
            CALL XABORT('MOC: INVALID FPARAM RECORD ON FLUX')
         ENDIF
         CALL LCMGET(IPFLUX,'STATE-VECTOR',ISTATE)
         ITYPEC= ISTATE(1)
         ILEAK=  ISTATE(2)
         IFRITR= ISTATE(3)
         IACITR= ISTATE(4)
         IREBAL= ISTATE(5)
         CALL LCMGET(IPFLUX,'EPS-CONVERGE',EPSX)
         AIEPS=EPSX(1)
         AEEPS=EPSX(2)
      ELSE
         ITYPEC= -99
         ILEAK=  0
         IFRITR= 3
         IACITR= 3
         IREBAL= 1       	
      ENDIF
      ILK= IREBAL.EQ.1
      REFKEF= DONE
            CALL MOCGET(LCACA ,LCACT ,NMU   ,ISYMM ,NGSS ,NANGL ,KTOPT ,
     >                  LDRFLX,LDAJCB,LMODE ,LEAKSW,ILK  ,LEXIN ,REFKEF,
     >                  ITYPEC,AIEPS ,AEEPS ,NEXTMX,NINTMX,IPRT ,NL,
     >                  NANIS ,ITRB  ,IFRITR,ILEAK ,IACITR,ISADJ,ITRANC,
     >                  NBN )
      IF(LCACA .EQ. -1) THEN
        IF(LCACT.NE.LCACT2) CALL XABORT( 'MOC: LCACT.NE.LCACT2 ')
        LCACA=LCACT
        IF(NMU .EQ. 0) NMU=1
        IF(NMU2 .EQ. 0) NMU2=1
        NGSS = NMU
        NGSS2= NMU2
      ELSE
        NGSS =(NANGL+1)/2
        NGSS2=(NANGL2+1)/2
        IF(KTOPT .EQ. 0) THEN 
          IF(ISYMM .GT. 1) THEN
            NGSS=NANGL
          ENDIF
        ENDIF
        IF(KTOPT2 .EQ. 0) THEN 
          IF(ISYMM2 .GT. 1) THEN
            NGSS2=NANGL2
          ENDIF
        ENDIF
        IF(LCACA .EQ. 3 ) THEN
          NGSS  = 2
          NGSS2 = 2
        ENDIF
      ENDIF
      CALL SETARA( A ,NUN*NGRP*NWORDS, IFLUXO )
      CALL SETARA( A ,2*8*NUN*NGRP, FLUX )
      CALL SETARA( A ,1*NUN*NGRP*NWORDS, IAJFLO )
      IF( JENTRY(1) .EQ. 0 )THEN
        CALL LCMSIX(IPFLUX,CDIRFL,1)
        CALL MOCGFL(IPFLUX,ITYPEC,NGRP,NUN,A(IFLUXO))
        CALL LCMSIX(IPFLUX,CDIRFL,2)
        IF (ISADJ .GT. 0) THEN
          CALL LCMSIX(IPFLUX,CADJFL(1),1)
          CALL MOCAGF(IPFLUX,ISADJ,NGRP,NUN,A(IAJFLO))
          CALL LCMSIX(IPFLUX,CADJFL(1),2)
        ENDIF 
      ENDIF
      CALL SETARA( I, MAXMIX, NJJ    )
      CALL SETARA( I, MAXMIX, IJJ    )
      CALL SETARA( I, MAXMIX, IPOS   )
      MAXM1= MAXMIX+1
      CALL SETARA( A, NGRP*MAXM1, XSOLD  )
      CALL SETARA( A, NGRP*MAXM1, XSSIGT )
      CALL SETARA( A, NGRP*MAXM1, XTINV  )
      CALL SETARA( A, NGRP*MAXM1, XSSIGW )
      CALL SETARA( A, MAXM1*NGRP*NIFIS, XSCHI )
      CALL SETARA( A, MAXM1*NGRP*NIFIS, XSNUF )
      CALL SETARA( A, MAXMIX*NIFIS, XSTK  )
      CALL SETARA( A, MAXM1*NGRP*NGRP*(NANIS+1), XSCAT  )
      CALL SETARA( A, MAXMIX*NGRP*NGRP, VSCAT  )
      CALL SETARA( A, NGRP, DIFFB1 )
      RKEFF = 1.0
      NGSS2 = NGSS
      CALL MOCDRV(IPFLUX,IPTRK,IPMACR,IFTRAK,NGRP,MAXMIX,NIFIS,NANIS,
     1 NL,NBN,NUN,A(IFLUXO),A(DIFFB1),NINTMX,AIEPS,NEXTMX,AEEPS,IFRITR,
     2 IACITR,ITYPEC,ILEAK,NREG,I(MATCOD),A(VOL),A(VOLINV),A(XSOLD),
     3 A(XSSIGT),A(XTINV),A(XSSIGW),A(XSCHI),A(XSNUF),A(XSTK),I(NJJ),
     4 I(IJJ),I(IPOS),A(XSCAT),A(VSCAT),NALB,A(ALBEDO),LEAKSW,ILK,
     6 ITRANC,ITRB,TITRE,LCACA,NGSS,LEXIN,REFKEF,IPRT,CDIRFL,A(IAJFLO),
     7 CADJFL,ISADJ,LDRFLX,LDAJCB,RKEFF,LMODE,IPTRK2,IFTRK2,NGSS2,
     8 A(FLUX) ) 
      CALL RLSARA( A(DIFFB1) )
      CALL RLSARA( A(VSCAT ) )
      CALL RLSARA( A(XSCAT ) )
      CALL RLSARA( A(XSTK  ) )
      CALL RLSARA( A(XSNUF ) )
      CALL RLSARA( A(XSCHI ) )
      CALL RLSARA( A(XSSIGW) )
      CALL RLSARA( A(XTINV ) )
      CALL RLSARA( A(XSSIGT) )
      CALL RLSARA( A(XSOLD ) )
      CALL RLSARA( I(IPOS  ) )
      CALL RLSARA( I(IJJ   ) )
      CALL RLSARA( I(NJJ   ) )
      CALL RLSARA( A(IFLUXO) )
      CALL RLSARA( A(FLUX) )
      CALL RLSARA( A(IAJFLO) )
      CALL XDISET(ISTATE,NSTATE,0)
      ISTATE(1)= ITYPEC
      ISTATE(2)= ILEAK
      ISTATE(3)= IFRITR
      ISTATE(4)= IACITR
      IF( ILK )THEN
         ISTATE(5)= 1
      ELSE
         ISTATE(5)= 0
      ENDIF
      ISTATE(6)=NINTMX
      ISTATE(7)=NEXTMX
      ISTATE(9)=NGRP
      ISTATE(10)=NUN
      CALL LCMPUT(IPFLUX,'STATE-VECTOR',NSTATE,1,ISTATE)
      EPSX(1)=AIEPS
      EPSX(2)=AEEPS
      EPSX(3)=AEEPS
      CALL LCMPUT(IPFLUX,'EPS-CONVERGE',3,2,EPSX)
      IF(IPRT.GE.3) CALL LCMLIB(IPFLUX)
      CALL RLSARA( A(ALBEDO) )
      CALL RLSARA( I(KEYFLX) )
      CALL RLSARA( A(VOLINV) )
      CALL RLSARA( A(VOL   ) )
      CALL RLSARA( I(MATCOD) )
      CALL LCMSIX( IPMACR, ' ', 0)
      CALL LCMSIX( IPTRK,  ' ', 0)
      RETURN
      END
