*DECK MOC2AC
      SUBROUTINE MOC2AC( NG, NF, NR, FLUX, AKEEP, IG0, MU,JGDEB )

*---------------------------  MOC2AC  ---------------------------------
*
*   1- PROGRAMME STATISTICS:
*       NAME     :  MOC2AC
*       USE      :  VARIATIONAL ACCELERATION (A. HEBERT)
*       AUTHOR   :  R. ROY (01/01/98)
*       MODIFIED :  
*
*   2- ROUTINE PARAMETERS:
*    INPUT
*       AKEEP    : THE STORED KEFF                    D(3)
*       IG0      : STARTING GROUP INDEX               I
*       JGDEB    : ENDING GROUP INDEX                 I
*       MU       : VARIATIONAL COEFFICIENT            D
*                  (SHOULD BE EQUAL TO 1)
*       NR       : NUMBER OF REGIONS                  I
*       NF       : NUMBER OF ANISOTROPIC ORDER        I
*       NG       : NUMBER OF ENERGY GROUPS            I
*
*    OUTPUT
*       FLUX     : FLUX                               D(NF,NR,NG,3)
*
*
*---------------------------   MOC2AC  --------------------------------
*
C
      IMPLICIT  NONE
      INTEGER   NR, NF, NG, IG0, IG, IF, IR,JGDEB
      REAL      MU
      DOUBLE PRECISION  FLUX(NF,NR,NG,3)
      DOUBLE PRECISION  AKEEP(3)
      DOUBLE PRECISION  DMU, R1, R2
      DOUBLE PRECISION  DONE, DZERO, NOM, DENOM
      PARAMETER ( DONE=1.0D0, DZERO=0.0D0 )
C 
C     MU CALCULATION
      NOM   = DZERO
      DENOM = DZERO
      DO  3 IG= IG0, (NG-JGDEB)
          DO  2 IR=1,NR
          DO  1 IF=1,NF
             R1 = FLUX(IF,IR,IG,2) - FLUX(IF,IR,IG,1)
             R2 = FLUX(IF,IR,IG,3) - FLUX(IF,IR,IG,2)
             NOM = NOM + R1*(R2-R1)
             DENOM = DENOM + (R2-R1)*(R2-R1)
    1     CONTINUE
    2     CONTINUE
    3 CONTINUE
C
      DMU = - NOM / DENOM
      MU  = REAL(DMU)
      IF( DMU.GT.DZERO )THEN

       DO  13 IG= IG0,(NG-JGDEB)

          DO  12 IR=1,NR
          DO  11 IF=1,NF
C
C           ACCELERATED VALUES FOR PHI(2) ET PHI(3)
            FLUX(IF,IR,IG,3) = FLUX(IF,IR,IG,2) + DMU *
     >        (FLUX(IF,IR,IG,3) - FLUX(IF,IR,IG,2))
            FLUX(IF,IR,IG,2) = FLUX(IF,IR,IG,1) + DMU *
     >        (FLUX(IF,IR,IG,2) - FLUX(IF,IR,IG,1))
   11     CONTINUE
   12     CONTINUE
   13  CONTINUE
       AKEEP(3)= AKEEP(2) + DMU * (AKEEP(3)-AKEEP(2))
       AKEEP(2)= AKEEP(1) + DMU * (AKEEP(2)-AKEEP(1))
      ELSE
       MU= 1.0
      ENDIF
C
      RETURN
      END
