*DECK MOC2HM
      SUBROUTINE MOC2HM(NGRP,NREG,NANIS,NMAT,NFUNL,NIFIS,KEYANI,MATCOD,
     >                  VOL ,FLUX,XSTOT,XSTRC,XSDIA,XSCAT,XSNUF,XSCHI,
     >                  PHI ,XCTOT,XCTRC,XCDIA,XCCAT,XCNUF,XCCHI,XCABS,
     >                  IPRT,LDIRECT,IPFLUX,DIRPIS,LEAKSW,LPISSW,PNOLKG,
     >                  OUTSOU,XCSOU)
*---------------------------  MOC2HM  ---------------------------------
*
*   1- PROGRAMME STATISTICS:
*       NAME     :  MOC2HM
*       USE      :  XS HOMOGENIZATION
*       AUTHOR   :  R. ROY (01/01/98)
*       MODIFIED :  MONCHAI A. (01/01/05)
*
*   2- ROUTINE PARAMETERS:
*    INPUT
*       FLUX     : FLUX ARRAY                         D(NFUNL,NREG,
*                                                       NGRP,8)
*       NGRP     : NUMBER OF ENERGY GROUPS            I
*       NREG     : NUMBER OF REGIONS                  I
*       NANIS    : NUMBER OF ANISOTROPY IN            I
*                  SCATTERING CROSS SECTIONS
*       NFUNL    : NUMBER OF LEGENDRE ORDER FOR FLUX  I
*       NIFIS    : NUMBER OF FISSILE ISOTOPES         I
*       MATCOD   : MATERIAL CODE IN REGIONS.          I(NREGIO)
*       PHI      : DOMAIN-INTEGRATED GROUP FLUXES     D(NGRP)
*       XSTOT    : GROUP TOTAL CROSS SECTION          R(NMAT+1)
*       XSTRC    : GROUP TRANSPORT-CORRECTED TOTAL    R(NMAT+1)
*                  CROSS SECTION       
*       XSDIA    : WITHIN GROUP SCATTERING            R(NMAT+1)
*                  CROSS SECTION
*       XSCAT    : GROUP SCATTERING CROSS SECTION     R(NMAT+1)
*
*    WORKING
*       PNOLKG   : NON-LEAKAGE PROBABILITY            D(NREG,NGRP)
*
*    OUTPUT
*       XCABS    : HOMOGENIZED ABSORPTION             D(NGRP)
*                  CROSS SECTION
*       XCCHI    : HOMOGENIZED CHI                    D(NGRP)
*       XCDIA    : HOMOGENIZED WITHIN-GROUP           D(NGRP)
*                  SCATTERING CROSS SECTION
*       XCCAT    : HOMOGENIZED GROUP                  D(NGRP,0:NANIS,NGRP)
*                  SCATTERING CROSS SECTION
*       XCNUF    : HOMOGENIZED NUSIGMA-F              D(NGRP)
*                  CROSS SECTION
*       XCSOU    : DOMAIN-INTEGRATED GROUP TOTAL      D(NGRP)
*                  FISSION + SCATTERING SOURCES
*       XCTRC    : HOMOGENIZED GROUP TRANSPORT-       D(NGRP)
*                  CORRECTED TOTAL CROSS SECTION
*---------------------------   MOC2HM  --------------------------------
      IMPLICIT NONE
      REAL        A
      COMMON      A(1)
      INTEGER     I(1)
      EQUIVALENCE (A(1),I(1))
      INTEGER IPFLUX,NGRP,NREG,NANIS,NMAT,NFUNL,MATCOD(NREG),
     >        KEYANI(NANIS)
      INTEGER IGRP,IREG,IANI, IPRT, JGRP, IFIS, NIFIS,IOUT
      REAL    VOL(NREG),
     >        XSTOT(0:NMAT,NGRP),XSTRC(0:NMAT,NGRP),XSDIA(0:NMAT,NGRP),
     >        XSCAT(NGRP,0:NMAT,0:NANIS,NGRP),
     >        XSNUF(0:NMAT,NIFIS,NGRP),XSCHI(0:NMAT,NIFIS,NGRP)
      DOUBLE PRECISION XCTOT(NGRP),XCABS(NGRP),XCCAT(NGRP,0:NANIS,NGRP),
     >        XCNUF(NGRP),XCCHI(NGRP),XCTRC(NGRP),XCDIA(NGRP),
     >        PHIC,F2NP1,PHI(NGRP),FISOUR,AKINV,DZERO,DONE
      LOGICAL  LDIRECT,LPISSW,LEAKSW
      INTEGER  ILCMLN,ILCMTY,ILCMUP,ILCMDN,IPIS 
      CHARACTER*12 NAMFLX,DIRPIS
      DOUBLE PRECISION    FLUX(NFUNL,NREG,NGRP),OUTSOU(NFUNL,NREG,NGRP),
     >                    XCSOU(NGRP),PNOLKG(NREG,NGRP)
      PARAMETER (IOUT=6,DZERO=0.0D0,DONE=1.0D0,ILCMUP=1,ILCMDN=2)
      AKINV=DZERO
      CALL SETARA(A,NREG,IPIS)
      DO 301 IREG= 1,NREG
       DO 302 IGRP= 1,NGRP
           PNOLKG(IREG,IGRP) = DONE 
302    CONTINUE
301   CONTINUE
      IF(LEAKSW .AND. LPISSW) THEN
        CALL LCMLEN(IPFLUX,DIRPIS,ILCMLN,ILCMTY)
        IF (ILCMLN.NE.-1) THEN
          CALL XABORT('MOC2HM:PIS DIRECTORY DOES NOT EXIST')
        ENDIF
        CALL LCMSIX(IPFLUX,DIRPIS,ILCMUP)
        DO 5 IGRP=1,NGRP
         WRITE(NAMFLX,'(4HPIS ,I3,1X)') IGRP 
         CALL LCMLEN(IPFLUX,NAMFLX,ILCMLN,ILCMTY)
         IF(ILCMLN.EQ.NREG) THEN
          CALL LCMGET(IPFLUX,NAMFLX,A(IPIS))
         ELSE
          CALL XABORT('MOC2HM:INVALID DATA LENGTH OF PIS IN IPFLUX')
         ENDIF
         DO 201 IREG=1,NREG
          PNOLKG(IREG,IGRP)=DONE-DBLE(A(IPIS-1+IREG))
          IF(IPRT.GT.1000)  WRITE(IOUT,'(1X,A8,2X,E14.6)')
     >      'PNOLKG =',PNOLKG(IREG,IGRP)
201      CONTINUE
5       CONTINUE
        CALL LCMSIX(IPFLUX,DIRPIS,ILCMDN) 
      ENDIF
         DO 98 IGRP= 1, NGRP
            XCSOU(IGRP)=DZERO
            DO 97 IREG=1,NREG
               XCSOU(IGRP)=XCSOU(IGRP)+PNOLKG(IREG,IGRP)*VOL(IREG)*
     >                     OUTSOU(1,IREG,IGRP)
97          CONTINUE
98       CONTINUE
      DO 50 IGRP= 1, NGRP
         PHI  (IGRP)=DZERO
         XCTOT(IGRP)=DZERO
         XCTRC(IGRP)=DZERO
         XCDIA(IGRP)=DZERO
         XCCHI(IGRP)=DZERO
         XCNUF(IGRP)=DZERO
         DO 10 IREG=1,NREG
            PHIC=FLUX(1,IREG,IGRP)*VOL(IREG)
            PHI(IGRP)=PHI(IGRP)+PHIC
            XCTOT(IGRP)=XCTOT(IGRP)+ XSTOT(MATCOD(IREG),IGRP)*PHIC
            XCTRC(IGRP)= XCTRC(IGRP)+ XSTRC(MATCOD(IREG),IGRP)*PHIC
            XCDIA(IGRP)= XCDIA(IGRP)+ XSDIA(MATCOD(IREG),IGRP)*PHIC*
     >                   PNOLKG(IREG,IGRP)
            DO 11 IFIS= 1, NIFIS
             IF(LDIRECT) THEN
              XCNUF(IGRP)=XCNUF(IGRP)+XSNUF(MATCOD(IREG),IFIS,IGRP)*PHIC
              AKINV= AKINV+ XSNUF(MATCOD(IREG),IFIS,IGRP)*PHIC
             ELSE
              XCCHI(IGRP)=XCCHI(IGRP)+XSCHI(MATCOD(IREG),IFIS,IGRP)*PHIC
              AKINV= AKINV+ XSCHI(MATCOD(IREG),IFIS,IGRP)*PHIC
             ENDIF
   11       CONTINUE
   10    CONTINUE
         IF(ABS(PHI(IGRP)).LT. 1.0D-15) CALL XABORT('MOC2HM: ZERO PHI')
         XCTOT(IGRP)= XCTOT(IGRP)/PHI(IGRP)
         XCTRC(IGRP)= XCTRC(IGRP)/PHI(IGRP)
         XCDIA(IGRP)= XCDIA(IGRP)/PHI(IGRP)
         XCABS(IGRP)= XCTOT(IGRP)
         IF(LDIRECT) THEN
           XCNUF(IGRP)= XCNUF(IGRP)/PHI(IGRP)
         ELSE
           XCCHI(IGRP)= XCCHI(IGRP)/PHI(IGRP)
         ENDIF
   50 CONTINUE
      DO 51 IGRP= 1, NGRP
         DO 40 JGRP= 1, NGRP
            DO 45 IANI= 0, NANIS
               XCCAT(IGRP,IANI,JGRP)= DZERO
               DO 30 IREG= 1, NREG
                  IF(LDIRECT) THEN
                   XCCAT(IGRP,IANI,JGRP)= XCCAT(IGRP,IANI,JGRP)+
     >             PNOLKG(IREG,JGRP)*XSCAT(IGRP,MATCOD(IREG),IANI,JGRP)* 
     >                               FLUX(1,IREG,IGRP)*VOL(IREG)
                  ELSE
                   XCCAT(IGRP,IANI,JGRP)= XCCAT(IGRP,IANI,JGRP)+
     >             PNOLKG(IREG,IGRP)*XSCAT(IGRP,MATCOD(IREG),IANI,JGRP)*
     >                               FLUX(1,IREG,JGRP)*VOL(IREG)
                  ENDIF
   30          CONTINUE
               IF(LDIRECT) THEN
                IF(ABS(PHI(IGRP)).LT.1.0D-15) 
     >            CALL XABORT('MOC2HM: ZERO PHI')
                XCCAT(IGRP,IANI,JGRP)= XCCAT(IGRP,IANI,JGRP)/PHI(IGRP)
               ELSE
                IF(ABS(PHI(JGRP)).LT.1.0D-15) 
     >            CALL XABORT('MOC2HM: ZERO PHI')
                XCCAT(IGRP,IANI,JGRP)= XCCAT(IGRP,IANI,JGRP)/PHI(JGRP)
               ENDIF
   45       CONTINUE
            XCABS(IGRP)= XCABS(IGRP)-XCCAT(IGRP,0,JGRP)
   40    CONTINUE
   51 CONTINUE
      AKINV= DONE/AKINV
      DO 90 IREG= 1, NREG
         DO 80 IFIS= 1, NIFIS
            FISOUR= DZERO
            DO 60 IGRP= 1, NGRP
              IF(LDIRECT) THEN
               FISOUR= FISOUR + XSNUF(MATCOD(IREG),IFIS,IGRP)*
     >                          FLUX(1,IREG,IGRP)
              ELSE
               FISOUR= FISOUR + XSCHI(MATCOD(IREG),IFIS,IGRP)*
     >                          FLUX(1,IREG,IGRP)
              ENDIF
   60       CONTINUE
            DO 70 IGRP= 1, NGRP
              IF(LDIRECT) THEN
               XCCHI(IGRP)= XCCHI(IGRP)+XSCHI(MATCOD(IREG),IFIS,IGRP)*
     >                      FISOUR*VOL(IREG) 
              ELSE
               XCNUF(IGRP)= XCNUF(IGRP)+XSNUF(MATCOD(IREG),IFIS,IGRP)*
     >                      FISOUR*VOL(IREG)
              ENDIF
   70       CONTINUE
   80    CONTINUE
   90 CONTINUE
      DO 100 IGRP= 1, NGRP
        IF(LDIRECT) THEN
           XCCHI(IGRP)= XCCHI(IGRP)*AKINV
        ELSE
           XCNUF(IGRP)= XCNUF(IGRP)*AKINV
        ENDIF
  100 CONTINUE
      IF( IPRT.GT.5 )THEN
         WRITE(IOUT,6000)
         WRITE(IOUT,6021)
         DO 1000 IGRP= 1, NGRP
            WRITE(IOUT,6023) IGRP,PHI(IGRP),
     >      XCTOT(IGRP),XCABS(IGRP),
     >      XCNUF(IGRP),XCCHI(IGRP),XCCAT(IGRP,0,IGRP),
     >      XCTOT(IGRP)-XCABS(IGRP)-XCCAT(IGRP,0,IGRP)
 1000    CONTINUE
         IF( IPRT.GT.10 )THEN
            DO 2000 IANI= 0, NANIS
               F2NP1= 1./(2.*REAL(IANI)+1.)
               WRITE(IOUT,6029) IANI,1,(JGRP,JGRP=1,NGRP)
               DO 1500 IGRP= 1, NGRP
                  WRITE(IOUT,6028) IGRP,
     >                   (XCCAT(IGRP,IANI,JGRP)*F2NP1,JGRP=1,NGRP)
 1500          CONTINUE
 2000       CONTINUE
         ENDIF
      ENDIF
      CALL RLSARA( A( IPIS  ) )
      RETURN
 6000 FORMAT(/' F L U X E S   A N D   H O M O G E N I Z E D   X - S'/
     > 1X,51(1H-))
 6021 FORMAT(1X,'GROUP',4X,'AVERAGE',8X,'TOTAL',7X,
     >'ABSORPTION',5X,'NUSIGF',8X,'FISSION',10X,'SCATTERING X-S'/11X,
     >'FLUX',11X,'X-S',11X,'X-S',10X,'X-S',
     >10X,'SPECTRUM',3X,'WITHIN GROUP',2X,'OUT OF GROUP')
 6023 FORMAT(1X,I4,1P,8E14.5)
 6028 FORMAT(3H I=,I4,2H: ,1P,10E12.4/(9X,10E12.4))
 6029 FORMAT(/' ORDER OF LEGENDRE: ',I2
     > /' SCATTERING TRANSFER X-S (I TOWARD J) IN REGION',I5,1H:
     > //(11X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,
     > I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,
     > 2HJ=,I4))
      END
