*DECK MOCCWP
      SUBROUTINE MOCCWP(IPFLUX,CCPDIR,NREG ,NGRP  ,NMAT  ,NANIS ,NSOUT,
     >                  MATALB,XSDIA ,XSCAT,LXSCAT,LEXTSO,IGDEB ,JGDEB,
     >                  LXSTYP,X,Y,Z,S,PMC)
*
*---------------------------  MOCCWP  ---------------------------------
*
* 1- PROGRAMME STATISTICS:
*
*     NAME     :  MOCCWP
*     USE      :  MOCC TRACK SWEEPING USING RESPONSE MATRIX
*     MODIFIED :  MONCHAI A. (24/02/05)   
*
* 2- ROUTINE PARAMETERS: 
*   INPUT
*       NGRP     : NUMBER OF ENERGY GROUPS            I
*       NREG     : NUMBER OF REGIONS                  I
*       NANIS    : NUMBER OF ANISOTROPY IN            I
*                  SCATTERING CROSS SECTIONS
*       NFUNL    : NUMBER OF LEGENDRE ORDER FOR FLUX  I
*       NIFIS    : NUMBER OF FISSILE ISOTOPES         I
*       NMAT     : NUMBER OF MIXTURES                 I
*       MATCOD   : MATERIAL CODE IN REGIONS.          I(NREG)
*       XSTOT    : GROUP TOTAL CROSS SECTION          R(NMAT+1)
*       XSTRC    : GROUP TRANSPORT-CORRECTED TOTAL    R(NMAT+1)
*                  CROSS SECTION       
*       XSDIA    : WITHIN GROUP SCATTERING            R(NMAT+1)
*                  CROSS SECTION
*       XSCAT    : GROUP SCATTERING CROSS SECTION     R(NMAT+1)
*
*   WORKING 
*           S    : DUMMY VARIABLE                     D(NREG,NGRP)
*           Z    : DUMMY VARIABLE                     D(NREG,NGRP)
*           X    : DUMMY VARIABLE                     D(NREG,NGRP)
*           Y    : DUMMY VARIABLE                     D(NREG,NGRP)
*--------------------------   MOCCWP    ------------------------------
*
      IMPLICIT NONE
      REAL        A
      COMMON      A(1)
      INTEGER     I(1)
      EQUIVALENCE (A(1),I(1))
      INTEGER      IPFLUX,NREG,NGRP,NMAT,NANIS,NSOUT,
     >             MATALB(-NSOUT:NREG),IGDEB,JGDEB
      INTEGER      IG,JG,IR,IREG,JREG,IOUT,IPRT,IGCAT,JGCAT
      REAL         XSDIA(0:NMAT,NGRP),
     >             XSCAT(NGRP,0:NMAT,0:NANIS,NGRP)
      REAL  PMC(NREG,NREG)
      DOUBLE PRECISION X(NREG,NGRP),Y(NREG,NGRP),Z(NREG,NGRP),
     >                 S(NREG,NGRP),DZERO  
      LOGICAL  LXSCAT,LEXTSO,LXSTYP
      CHARACTER*12 NAMFLX,CCPDIR
      INTEGER      ILCMLN,ILCMTY,ILCMUP,ILCMDN
      PARAMETER(IOUT=6,ILCMUP=1,ILCMDN=2)
      DZERO = 0.00000000000D+0
      DO 45 IG=NGRP-JGDEB,IGDEB,-1 
         DO 65 IR= 1,NREG
            IF (LEXTSO ) THEN
              S(IR,IG)= Y(IR,IG)
            ELSE
              S(IR,IG)= DZERO
            ENDIF
            IF (LXSCAT ) THEN
              DO 35 JG= 1,NGRP
                IF( IG.EQ.JG )THEN
                 S(IR,IG)= S(IR,IG)+XSDIA(MATALB(IR),JG)*X(IR,JG)
                ELSE
                 IF (LXSTYP) THEN
                  IGCAT = JG
                  JGCAT = IG
                 ELSE
                  IGCAT = IG
                  JGCAT = JG
                 ENDIF
                 S(IR,IG)= S(IR,IG)+XSCAT(IGCAT,MATALB(IR),0,JGCAT)*
     >                     X(IR,JG)
                ENDIF
   35         CONTINUE
            ENDIF
   65    CONTINUE
         CALL LCMSIX(IPFLUX,CCPDIR,ILCMUP)
         WRITE(NAMFLX,'(4HP_JI,I3,1X)') IG 
         CALL LCMLEN(IPFLUX,NAMFLX,ILCMLN,ILCMTY)
         IF(ILCMLN.EQ.NREG*NREG.AND.ILCMTY.EQ.2) THEN
          CALL LCMGET(IPFLUX,NAMFLX,PMC) 
         ELSE
         CALL XABORT('MOCCWP:INVALID DATA LENGTH/TYPE MATRIX IN IPFLUX')
         ENDIF
         CALL LCMSIX(IPFLUX,CCPDIR,ILCMDN) 
         DO 2001 JREG=1,NREG
          Z(JREG,IG)=DZERO 
          DO 3001 IREG=1,NREG
           Z(JREG,IG)=Z(JREG,IG)+PMC(JREG,IREG)*S(IREG,IG)
3001      CONTINUE
2001     CONTINUE
 45   CONTINUE
      RETURN
      END