*DECK MOCGAD
      SUBROUTINE MOCGAD(IPFLUX,NREG ,NGRP  ,NFUNL ,NIFIS ,NMAT  ,NSOUT,
     >                  ADJFLO,FLUXO,XSCHI ,XSNUF,ADJFLX ,MATALB,VOL  ,
     >                  SCALE ,LORTHO,IPRT)
*
* ---------------------------  MOCGAD  ---------------------------------
* 
*  1- PROGRAMME STATISTICS:
*      NAME     :  MOCGAD
*      USE      :  THE GENERALIZED ADJOINT FLUX DECONTAMINATION
*      MODIFIED BY :  MONCHAI A. (24/02/05)  
* 
*  2- ROUTINE PARAMETERS:
*    INPUT
*      ADJFLX   : ADJOINT FLUX ARRAY                           D(NFUNL,
*                                                                NREG,
*                                                                NGRP,8)
*      ADJFLO   : GLOBAL ADJOINT FLUX ARRAY                    R(NUN,
*                                                                NFUNL,
*                                                                NGRP)
*      FLUXO    : GLOBAL DIRECT FLUX ARRAY                     R(NUN,
*                                                                NFUNL,
*                                                                NGRP)
*      LORTHO   : FLAF TO ORTHOGONAL DECONTAMICATION           L
*      MATALB   : MATERIAL CODE IN REGIONS.                    I(-NSOUT:
*                                                                NREG)
*      NFUNL    : NUMBER OF LEGENDRE ORDER FOR FLUX            I
*      NIFIS    : NUMBER OF FISSILE ISOTOPES                   I
*      NGRP     : NUMBER OF GROUPS TREATED                     I
*      NMAT     : NUMBER OF MIXTURES CONSIDERED                I
*      NREG     : NUMBER OF REGIONS CONSIDERED                 I
*      NSOUT    : NUMBER OF SURFACES CONSIDERED                I
*      SCALE    : SCALEUP BIASING FACTOR                       R
*      VOL      : VOLUME OF REGION                             R(NREG)
*      XSDIA    : WITHIN GROUP SCATTERING                      R(NMAT+1)
*                 CROSS SECTION
*      XSCAT    : GROUP SCATTERING CROSS SECTION               R(NMAT+1)
*      XSCHI    : FISSION NEUTRON DISTRIBUTION                 R(0:NMAT,
*                                                                NIFIS,
*                                                                NGRP)
*      XSNUF    : GROUP FISSION NEUTRON PRODUCTION             R(0:NMAT,
*                 CROSS SECTION                                  NIFIS,
*                                                                NGRP)
* --------------------------   MOCGAD    ------------------------------
*
      IMPLICIT NONE
      CHARACTER*12 NAMFLX
      INTEGER      IPFLUX,NREG ,NGRP  ,NFUNL ,NIFIS ,NMAT,NSOUT
      INTEGER      IG,JG,IR,IS,IOUT,IPRT
      INTEGER      MATALB(-NSOUT:NREG)
      REAL         ADJFLO(NREG,NFUNL,NGRP),FLUXO( NREG,NFUNL,NGRP)
      REAL    XSNUF(0:NMAT,NIFIS,NGRP),XSCHI(0:NMAT,NIFIS,NGRP)
      DOUBLE PRECISION ADJFLX(NFUNL,NREG,NGRP),ALFA,FISOUR,NOM,DENOM,
     >                 DZERO
      REAL    VOL(NREG),SCALE
      LOGICAL LORTHO
      IOUT=6
      DZERO = 0.0D0
      NOM   = DZERO
      DENOM = DZERO
      DO 96 IR=1,NREG
      DO 95 IS=1,NIFIS
       FISOUR=DZERO
       DO 93 IG=1,NGRP
        FISOUR=FISOUR+XSNUF(MATALB(IR),IS,IG)*FLUXO(IR,1,IG)
   93  CONTINUE
       DO 94 IG= 1,NGRP
        IF (LORTHO) THEN
           NOM  =NOM+DBLE(ADJFLX(1,IR,IG)*ADJFLO(IR,1,IG) )
           DENOM=DENOM+DBLE(ADJFLO(IR,1,IG)*ADJFLO(IR,1,IG) )
        ELSE
           NOM  =NOM+DBLE(VOL(IR)*ADJFLX(1,IR,IG)* 
     >           XSCHI(MATALB(IR),IS,IG))*FISOUR 
           DENOM=DENOM+DBLE(VOL(IR)*ADJFLO(IR,1,IG)*
     >           XSCHI(MATALB(IR),IS,IG))*FISOUR
        ENDIF
   94  CONTINUE
 95   CONTINUE
96    CONTINUE
      ALFA = -NOM/DENOM
      DO 100 IR= 1,NREG
       DO 200 IG= 1,NGRP
        ADJFLX(1,IR,IG)=ADJFLX(1,IR,IG)+(REAL(ALFA)+SCALE)
     >                  *ADJFLO(IR,1,IG)
200    CONTINUE
100   CONTINUE
      RETURN
      END