*DECK PERIXS
      SUBROUTINE  PERIXS(IPEDIT,NAMSAV,NGCOND,NMERGE,NL    ,ITRANC,
     >                   NIFISS,NEDMAC,NTAUXT,NNAM  ,NAMEAD,NAME  ,
     >                   INDICE,IXSFL ,HVECT ,EIGENK,RATECM,SCATTD,
     >                   SCATC ,IJJ   ,NJJ   ,
     >                   IPOS  ,FACT)
C
C
C---------------------------  PERIXS  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : PERIXS
C      USE      : READ HOMOGENIZED / MERGED XS
C      AUTHOR   : T. COURAU 2000/08/01
C      REMARK   : THIS ROUTINE IS INSPIRED FROM MACIXS
C
C  2- ROUTINE PARAMETERS:
C    INPUT / OUTPUT
C      IPEDIT   : POINTER TO THE GENERALIZED            I
C                 ADJOINT SOURCES & INTEGRAL PROPERTIES
C      NAMSAV   : NAME OF THE RECORD WHERE
C                 THE HOMOGENIZED XS A PRINTED          C(12)
C      NGCOND   : NUMBER OF GROUPS CONDENSED            I
C      NMERGE   : NUMBER OF REGIONS MERGED              I
C      NL       : NUMBER OF LEGENDRE ORDERS             I
C      ITRANC   : TYPE OF TRANSPORT CORRECTION          I
C      NIFISS   : NUMBER OF FISSILE ISOTOPES            I
C      NEDMAC   : NUMBER OF ADITIONAL EDITION X-S       I
C      NTAUXT   : NUMBER OF REACTION RATE EDITS         I
C      NNAM     : NUMBER OF STANDARD XS TREATED         I
C      NAMEAD   : EXTRA EDIT NAMES                      I(2,NEDMAC)
C      NAME     : LIST OF STANDARD XS CONSIDERED        C(NNAM)*6
C      INDICE   : INDEX OF THE STANDARD XS              I(NNAM)
C                        STORED IN RATECM
C      IXSFL    : FLAG FOR THE XS TO BE TREATED         I(NNAM+1)
C                1 TOTAL, 2 TRANC, 3 NUSIGF, 4 NFTOT,
C                5 CHI, 6  SCAD
C      HVECT    : EXTRA EDIT NAMES                      C(NEDMAC)*8
C      EIGENK   : EIGENVALUE FOR PROBLEM                R
C      RATECM   : AVERAGED REGION/GROUP X-S             D(0:NMERGE,
C                 = RATECM(*,1) = FLUXES                  NGCOND,NTAUXT)
C                 = RATECM(*,2) = TOTAL
C                 = RATECM(*,3) = ABS
C                 = RATECM(*,4) = FISSIONS
C                 = RATECM(*,5) = PRODUCTIONS
C                 = RATECM(*,6) = TOTAL LEAKAGES
C                 = RATECM(*,7) = TOTAL OUT OF GROUP SCATTERING
C                 = RATECM(*,8) = DIAGONAL SCATTERING X-S
C                 = RATECM(*,9) = CHI
C                 = RATECM(*,10) = WIMS TYPE TRANSPORT CORRECTION
C                 = RATECM(*,11) = X-DIRECTED LEAKAGES
C                 = RATECM(*,12) = Y-DIRECTED LEAKAGES
C                 = RATECM(*,13) = Z-DIRECTED LEAKAGES
C                 = RATECM(*,*,13+JJ) NUSIGF FOR JJ
C                 = RATECM(*,*,13+NIFISS+JJ) CHI FOR JJ
C                 = RATECM(*,*,13+2*NIFISS+JJ) NFTOT FOR JJ
C                 = RATECM(*,*,13+3*NIFISS+IL) SIGS FOR IL
C                 = RATECM(*,*,13+3*NIFISS+NL+IE) EDIT IE
C                 = RATECM(*,*,NTAUXT)= 1/V MERGE CONDENSED
C      SCATTD   : DOUBLE PRECISION SCATTERING RATES     D(NMERGE,NGCOND,
C                                                         NGCOND,NL)
C    WORK:
C      SCATC    : COMPRESS SCATTERING                   R(NMERGE*NGCOND)
C      IJJ      : POSITION OF FIRST DIFFUSION GROUP     I(NMERGE)
C      NJJ      : NUMBER OF DIFFUSION GROUP             I(NMERGE)
C      IPOS     : POSITION OF DIFFUSION GROUP           I(NMERGE)
C      FACT     : VECTOR STORING THE GROUP XS           R(NMERGE)
C
C  3- INTERNAL PARAMETERS:
C
C      IOUT    : OUTPUT UNIT = 6                    I
C      CGRPNM  : GROUP INDEX NAME FOR LCM           C*12
C
C---------------------------   SADPSA  --------------------------------
C
      IMPLICIT          NONE
      INTEGER           IOUT,ILCMUP,ILCMDN
      CHARACTER         NAMSBR
      PARAMETER        (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='PERIXS')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER           IPEDIT,NGCOND,NMERGE,NL,ITRANC,NNAM,NIFISS,
     >                  NEDMAC,NTAUXT,NAMEAD(2,NEDMAC),
     >                  INDICE(NNAM),IXSFL(NNAM+1),IJJ(NMERGE),
     >                  NJJ(NMERGE),IPOS(NMERGE)
      REAL              EIGENK,SCATC(NMERGE*NGCOND),FACT(NMERGE)
      CHARACTER         HVECT(NEDMAC)*8,NAME(NNAM)*6,NAMSAV*12
      DOUBLE PRECISION  RATECM(0:NMERGE,NGCOND,NTAUXT),
     >                  SCATTD(NMERGE,NGCOND,NGCOND,NL)
C----
C  LOCAL PARAMETERS
C----
      CHARACTER         CM*2,CGRPNM*12,NAMREC*12
      INTEGER           INAM,IMRG,IGRC,ID,IL,JGRC,IPOSIT,J2,J1,
     >                  ILCMLN,ILCMTY
      CALL XDDSET(RATECM,(NMERGE+1)*NGCOND*NTAUXT,0.0D0)
      CALL XDDSET(SCATTD,NMERGE*NGCOND*NGCOND*NL,0.0D0)
C---
C SET INTEGRATED FLUX TO 1.0D0
C AS THE XS ARE ALREADY COMPUTED
C--
      DO 10 IGRC=1,NGCOND
       DO 20 IMRG=1,NMERGE
         RATECM(IMRG,IGRC,1)=1.0D0
 20    CONTINUE
 10   CONTINUE
C---
C TREAT STANDARD XS
C---
      CALL LCMSIX(IPEDIT,NAMSAV,ILCMUP)
      DO 100 IGRC=1,NGCOND
       WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGRC,NGCOND
       CALL LCMSIX(IPEDIT,CGRPNM,ILCMUP)
       DO 200 INAM=1,NNAM
        ID=INDICE(INAM)
        IF(ID.GT.0 .AND. IXSFL(INAM).EQ.1) THEN
          CALL LCMGET(IPEDIT,NAME(INAM),FACT)
          IF (INAM.EQ.1 .OR. INAM.EQ.2 .OR. INAM.EQ.6) THEN
C---
C TOTAL AND TRANC
C--
           DO 300 IMRG=1,NMERGE
            RATECM(IMRG,IGRC,ID)=DBLE(FACT(IMRG))
 300       CONTINUE
          ELSE IF(INAM.EQ.3 .OR. INAM.EQ.4) THEN
C----
C NUSIGF AND NFTOT XS
C----
           DO 400 IMRG=1,NMERGE
             RATECM(IMRG,IGRC,ID+1)=DBLE(FACT(IMRG))
 400       CONTINUE
          ENDIF
        ENDIF
 200   CONTINUE
C----
C  READ OR INITIALISE SCATTERING CROSS SECTIONS
C----
c$$$       DO 500 IL=1,NL
          IL=1
          WRITE(CM,'(I2)') IL-1
          NAMREC='NJJD'//CM
          CALL LCMLEN(IPEDIT,NAMREC,ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0 .AND. IXSFL(NNAM+1).EQ.1 ) THEN
C----
C  READ COMPRESS SCATTERING XS PLUS INFORMATION TO EXPAND XS
C----
            CALL LCMGET(IPEDIT,NAMREC,NJJ)
            NAMREC='SCAD'//CM
            CALL LCMGET(IPEDIT,NAMREC,SCATC)
            NAMREC='IJJD'//CM
            CALL LCMGET(IPEDIT,NAMREC,IJJ)
C----
C  EXPAND SCATTERING XS TO XSSCAT(JGROUP,IMATER,IANIS,IGROUP)
C  WHERE IGROUP IS THE SECONDARY GROUP.
C----
            IPOSIT=1
            DO 510 IMRG=1,NMERGE
              IF(NJJ(IMRG) .GT. 0) THEN
                J2=IJJ(IMRG)
                J1=J2-NJJ(IMRG)+1
                DO 520 JGRC=J2,J1,-1
                  SCATTD(IMRG,IGRC,JGRC,IL)=DBLE(SCATC(IPOSIT))
                  IPOSIT=IPOSIT+1
 520            CONTINUE
              ENDIF
 510       CONTINUE
          ENDIF
c$$$ 500    CONTINUE
       CALL LCMSIX(IPEDIT,CGRPNM,ILCMDN)
 100  CONTINUE
       CALL LCMSIX(IPEDIT,NAMSAV,ILCMDN)
      RETURN
      END
