*DECK PIJNOS
      SUBROUTINE PIJNOS(NREGIO,VOLUME,PIJSYM,PIJSCT)
C
C---------------------------  PIJNOS  ---------------------------------
C
C   1-  PROGRAMME STATISTICS:
C
C          NAME       :  PIJNOS (VECTORIZE COMPILATION POSSIBLE)
C          FUNCTION   :  CP MATRIX WITHOUT SCATTERING MODIFICATION
C          DATE       :  27-03-1991
C          MODIFIED   :  94-07-21  (I. PETROVIC, G. MARLEAU)
C          AUTHOR     :  R.ROY
C
C   2-  PARAMETRES D'ENTREE ET DE RETOUR:
C
C         NREGIO  : NUMBER OF REGIONS CONSIDERED        I            I
C         VOLUME  : VOLUME OF REGION                    R(NREGIO)    I
C         PIJSCT  : PIJ OR PIJK OR PIJK* MATRIX         R(2*NREGIO**2)D
C         PIJSYM  : GROUP CONDENSED REDUCE/SYMMETRIC    R(NREGIO*
C                   PIJ OR PIJK MATRIX                 (NREGIO+1)/2  D
C         ITYP    : 7 DIRECTIONAL PIJK*                 I
C         PIJSYM  : GROUP FULL DIRECTIONAL PIJK* MATRIX R(NREGIO**2)
C
C---------------------------   PIJNOS  --------------------------------
C
      IMPLICIT NONE
C----
C INTERNAL FUNCTION
C-----
      INTEGER    INDPOS
C----
C VARIABLES
C----
      INTEGER    NREGIO,INDPIJ,I,J
      REAL       FACT
      REAL       VOLUME(*),PIJSYM(*),PIJSCT(NREGIO,*)
C----
C  INTRINSIC FUNCTION FOR POSITION IN CONDENSE PIJ MATRIX
C----
      INDPOS(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
C----
C  DIVIDE PIJSYM BY VOLUME
C----
      DO 20 I=1,NREGIO
        FACT=1.0/VOLUME(I)
        DO 10 J=1,NREGIO
          INDPIJ=INDPOS(I,J)
          PIJSCT(I,J)=FACT*PIJSYM(INDPIJ)
 10     CONTINUE
 20   CONTINUE
      RETURN
      END
