*DECK SYBILP
      SUBROUTINE SYBILP(IPSYS ,IPTRK ,IFTRAK,IMPX  ,NREG  ,NBMIX ,
     >                  MAT   ,VOL   ,KNORM ,NELPIJ,IPIJK ,ILK   ,
     >                  TITR  ,SIGT0 ,PIJ   )
*
*-----------------------------------------------------------------------
*
* CALCULATION OF THE COLLISION PROBABILITIES FOR SYBIL.
*
* GENERAL PARAMETERS:
*   IPSYS  : POINTER TO THE PIJ -> NOT USED
*   IPTRK  : POINTER TO THE TRACKING (L_TRACK SIGNATURE).
*   IFTRAK : FILE UNIT NUMBER FOR TRACKS -> NOT USED
*   IMPX   : PRINT FLAG. EQUAL TO ZERO FOR NO PRINT.
*   NREG   : TOTAL NUMBER OF MERGED BLOCKS FOR WHICH SPECIFIC VALUES
*            OF THE NEUTRON FLUX AND REACTIONS RATES ARE REQUIRED.
*   NBMIX  : NUMBER OF MIXTURES.
*   MAT    : INDEX-NUMBER OF THE MIXTURE TYPE ASSIGNED TO EACH VOLUME.
*            DIMENSION MAT(NREG)
*   VOL    : VOLUMES. DIMENSION VOL(NREG)
*   KNORM  : NOT USED.
*   NELPIJ : NUMBER OF ELEMENTS IN PIJ MATRIX
*   IPIJK  : PIJ OPTION   =1 PIJ, =4 PIJK
*   ILK    : ILK=.TRUE. IF NEUTRON LEAKAGE THROUGH EXTERNAL BOUNDARY
*            IS PRESENT.
*   TITR   : TITLE.
*   SIGT0  : TOTAL MACROSCOPIC CROSS SECTIONS ORDERED BY MIXTURE.
*            DIMENSION SIGT0(IR) WHERE IR=MAX(MAT(I))
*   PIJ    : REDUCED AND SYMMETRIZED COLLISION PROBABILITIES.
*            DIMENSION PIJ(NELPIJ)
*
*---------------------------------------------- A. HEBERT 19/05/87 -----
*
      PARAMETER (EPS1=1.0E-4,NSTATE=40)
      LOGICAL ILK
      INTEGER   NBMIX
      CHARACTER*72 TITR
      DIMENSION VOL(*),MAT(*),SIGT0(0:NBMIX),PIJ(NELPIJ),ISTATE(NSTATE)
      COMMON BASE(1)
*
* RECOVER SYBIL SPECIFIC PARAMETERS.
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPTRK,'STATE-VECTOR',ISTATE)
      ITG=ISTATE(7)
*
      CALL SETARA(BASE,NREG,ISIGT)
      CALL SETARA(BASE,NREG*NREG,IP)
      DO 55 I=1,NREG
   55 BASE(ISIGT+I-1)=SIGT0(MAT(I))
      CALL SYBCP1 (IPTRK,ITG,IMPX,NREG,BASE(ISIGT),BASE(IP))
*
      IF((IMPX.GE.10).OR.(IMPX.LT.0)) THEN
*        CHECK THE RECIPROCITY CONDITIONS.
         VOLTOT=0.0
         DO 95 I=1,NREG
   95    VOLTOT=VOLTOT+VOL(I)
         VOLTOT=VOLTOT/REAL(NREG)
         WRK=0.0
         DO 100 I=1,NREG
         DO 100 J=1,NREG
  100    WRK=MAX(WRK,ABS(BASE(IP+(J-1)*NREG+I-1)*VOL(I)
     1   -BASE(IP+(I-1)*NREG+J-1)*VOL(J))/VOLTOT)
         IF(WRK.GE.EPS1) WRITE (6,150) WRK
*        CHECK THE CONSERVATION CONDITIONS.
         IF(.NOT.ILK) THEN
            WRK=0.0
            DO 120 I=1,NREG
            F1=1.0
            DO 110 J=1,NREG
  110       F1=F1-BASE(IP+(J-1)*NREG+I-1)*BASE(ISIGT+J-1)
  120       WRK=AMAX1(WRK,ABS(F1))
            IF(WRK.GE.EPS1) WRITE (6,160) WRK
         ENDIF
      ENDIF
*
      IC=0
      DO 125 IKK=1,NREG
      IOF=(IKK-1)*NREG
      DO 125 JKK=1,IKK
      IC=IC+1
  125 PIJ(IC)=BASE(IP+IOF+JKK-1)*VOL(JKK)
      CALL RLSARA(BASE(IP))
      CALL RLSARA(BASE(ISIGT))
      RETURN
*
  150 FORMAT (/50H THE REDUCED PIJ DO NOT MEET THE RECIPROCITY CONDI,
     1 14HTIONS. RECIP =,1P,E10.3/)
  160 FORMAT (/50H THE REDUCED PIJ DO NOT MEET THE CONSERVATION COND,
     1 14HITIONS. LEAK =,1P,E10.3/)
      END
