*DECK SYBTRK
      SUBROUTINE SYBTRK (IPTRK,IPGEOM,IMPX,MAXPTS,MAXJ,MAXZ,TITLE,MULTC,
     1 IWIGN,IHALT,ILIGN,INORM,IRECT,IQW,JQUA1,JQUA2,IQUA10,MAT,VOL,IDL)
*
*-----------------------------------------------------------------------
*
* RECOVERY OF THE GEOMETRY AND TRACKING FOR SYBIL MODULES.
*
* GENERAL PARAMETERS:
*  IPTRK  : POINTER TO THE SYBIL TRACKING (L_TRACK SIGNATURE).
*  IPGEOM : POINTER TO THE GEOMETRY (L_GEOM SIGNATURE).
*  IMPX   : PRINT FLAG.
*  MAXPTS : ALLOCATED STORAGE FOR ARRAYS OF DIMENSION NREG.
*  MAXJ   : ALLOCATED STORAGE FOR INTERFACE CURRENT ARRAYS.
*  MAXZ   : ALLOCATED STORAGE FOR TRACKING ARRAYS.
*  TITLE  : CHARACTER*72 TITLE.
*  MULTC  : TYPE OF MULTICELL APPROXIMATION IN EURYDICE.
*  IWIGN  : TYPE OF CYLINDERIZATION.
*  IHALT  : =1: STOP AT THE END OF TRACKING.
*  ILIGN  : ON/OFF FOR TRACK PRINTOUT.
*  INORM  : ON/OFF FOR TRACK NORMALIZATION.
*  IRECT  : ON/OFF FOR USING SYMMETRIES IN SQUARE CELLS.
*  IQW    : TYPE ON QUADRATURES.
*  JQUA1  : 1-D QUADRATURE PARAMETER.
*  JQUA2  : 2-D QUADRATURE PARAMETERS. DIMENSION JQUA2(2)
*  IQUA10 : QUADRATURE PARAMETER FOR MICRO-STRUCTURES IN BIHET.
*
* SCRATCH STORAGE:
*  MAT    : DIMENSION MAT(MAXPTS)
*  VOL    : DIMENSION VOL(MAXPTS)
*  IDL    : DIMENSION IDL(MAXPTS)
*
*---------------------------------------------- A. HEBERT 19/05/87 -----
*
      PARAMETER (PI=3.141592654,NSTATE=40)
      LOGICAL ILK
      CHARACTER TITLE*(*)
      DIMENSION MAT(*),VOL(*),IDL(*),ISTATE(NSTATE),JQUA2(2),IQUAD(4),
     1          IBASE(1)
      COMMON    BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPGEOM,'STATE-VECTOR',ISTATE)
      ITYGEO=ISTATE(1)
      ITYNRE=ISTATE(6)
      ITYASM=ISTATE(9)
      ITYGDH=ISTATE(12)
      ITYCLS=ISTATE(13)
      IF(ITYGEO.EQ.1) THEN
         ITG=1
         IF(ITYNRE.NE.1) CALL XABORT('SYBTRK: INVALID NUMBER OF REGI'
     1   //'ONS.')
         CALL LCMLEN(IPGEOM,'MIX',NMILG,ITYLCM)
         IF(NMILG.NE.1) CALL XABORT('SYBTRK: INVALID MIX VECTOR.')
         CALL LCMGET(IPGEOM,'MIX',MAT(1))
         IR=MAT(1)
         VOL(1)=1.0
         ILK=.FALSE.
         NREG=1
      ELSE IF((ITYGEO.GT.1).AND.(ITYGEO.LT.5).AND.
     >        (ITYASM.EQ.0)) THEN
         ITG=2
         CALL SETARA(BASE,MAXPTS+1,IXX2)
         CALL SETARA(BASE,MAXPTS+1,IYY2)
         CALL SETARA(BASE,MAXPTS+1,IZZ2)
         CALL SETARA(IBASE,6,INCODE)
         CALL SETARA(BASE,6,IZCODE)
*
         CALL SETARA(BASE,MAXPTS,IISPLX)
         CALL SETARA(BASE,MAXPTS,IISPLY)
         CALL SETARA(BASE,MAXPTS,IISPLZ)
         CALL READ3D(MAXPTS,MAXPTS,MAXPTS,MAXPTS,IPGEOM,IHEX,IR,MAT,
     1   ILK,SIDE,BASE(IXX2),BASE(IYY2),BASE(IZZ2),IMPX,LX,LY,LZ,NREG,
     2   IBASE(INCODE),BASE(IZCODE),BASE(IISPLX),BASE(IISPLY),
     3   BASE(IISPLZ))
         CALL RLSARA(BASE(IISPLZ))
         CALL RLSARA(BASE(IISPLY))
         CALL RLSARA(BASE(IISPLX))
         DO 10 IC=1,6
         IF(IBASE(INCODE+IC-1).EQ.7) CALL XABORT('SYBTRK: ZERO FLUX BOU'
     1   //'NDARY CONDITION NOT PERMITTED.')
   10    CONTINUE
*
*        COMPUTATION OF THE VOLUMES.
         DO 20 IKK=1,NREG
         A=BASE(IXX2+IKK-1)
         B=BASE(IXX2+IKK)
         IF(ITYGEO.EQ.2) THEN
            VOL(IKK)=(B-A)
         ELSE IF(ITYGEO.EQ.3) THEN
            VOL(IKK)=PI*(B-A)*(B+A)
         ELSE IF(ITYGEO.EQ.4) THEN
            VOL(IKK)=4.0*PI*(B-A)*(A*A+A*B+B*B)/3.0
         ENDIF
   20    CONTINUE
         IF(IMPX.GE.1) WRITE (6,'(/29H QUADRATURE PARAMETER JQUA1 =,
     1   I2/)') JQUA1
*
         CALL XDISET(ISTATE,NSTATE,0)
         ISTATE(1)=ITYGEO
         ISTATE(2)=IHEX
         ISTATE(3)=JQUA1
         ISTATE(4)=LX
         ISTATE(5)=LY
         ISTATE(6)=LZ
         CALL LCMSIX(IPTRK,'PURE-GEOM',1)
         CALL LCMPUT(IPTRK,'PARAM    ',6,1,ISTATE)
         CALL LCMPUT(IPTRK,'XXX',LX+1,2,BASE(IXX2))
         CALL LCMPUT(IPTRK,'YYY',LY+1,2,BASE(IYY2))
         CALL LCMPUT(IPTRK,'ZZZ',LZ+1,2,BASE(IZZ2))
         CALL LCMPOF(IPTRK,'NCODE',6,1,INCODE)
         CALL LCMPOF(IPTRK,'ZCODE',6,2,IZCODE)
         IF(ITYGEO.GE.8) CALL LCMPUT(IPTRK,'SIDE',1,2,SIDE)
         CALL LCMSIX(IPTRK,' ',2)
         CALL RLSARA(BASE(IZZ2))
         CALL RLSARA(BASE(IYY2))
         CALL RLSARA(BASE(IXX2))
      ELSE IF(ITYGEO.EQ.30) THEN
         ITG=3
         CALL SETARA(IBASE,1+MAXPTS,INMC3)
         CALL SETARA(BASE,2*MAXPTS,IRAYR3)
         CALL SETARA(BASE,MAXPTS**2,IPROCE)
         CALL SETARA(BASE,MAXPTS,IPOURC)
         CALL SETARA(BASE,MAXPTS,ISURFA)
*
         CALL SETARA(BASE,MAXPTS,INBREG)
         CALL SETARA(BASE,MAXPTS,IMILIE)
         CALL SETARA(BASE,MAXPTS,IRAYZO)
         CALL SETARA(BASE,3*MAXPTS,ICELL)
         CALL READMT (MAXPTS,IPGEOM,IR,MAT,VOL,ILK,ISTAT,NSUPCE,
     1   NREG,IBASE(INMC3),BASE(IRAYR3),BASE(IPROCE),BASE(IPOURC),
     2   BASE(ISURFA),IMPX,BASE(INBREG),BASE(IMILIE),BASE(IRAYZO),
     3   BASE(ICELL))
         CALL RLSARA(BASE(ICELL))
         CALL RLSARA(BASE(IRAYZO))
         CALL RLSARA(BASE(IMILIE))
         CALL RLSARA(BASE(INBREG))
         IF(IMPX.GE.1) WRITE (6,'(/29H QUADRATURE PARAMETER JQUA1 =,
     1   I2/)') JQUA1
*
         CALL XDISET(ISTATE,NSTATE,0)
         ISTATE(1)=NSUPCE
         ISTATE(2)=JQUA1
         ISTATE(3)=ISTAT
         CALL LCMSIX(IPTRK,'DOITYOURSELF',1)
         CALL LCMPUT(IPTRK,'PARAM       ',3,1,ISTATE)
         CALL LCMPUT(IPTRK,'NMC',1+NSUPCE,1,IBASE(INMC3))
         CALL LCMPUT(IPTRK,'RAYRE',NREG+NSUPCE,2,BASE(IRAYR3))
         CALL LCMPUT(IPTRK,'PROCEL',NSUPCE**2,2,BASE(IPROCE))
         CALL LCMPUT(IPTRK,'POURCE',NSUPCE,2,BASE(IPOURC))
         CALL LCMPUT(IPTRK,'SURFA',NSUPCE,2,BASE(ISURFA))
         CALL LCMSIX(IPTRK,' ',2)
         CALL RLSARA(BASE(ISURFA))
         CALL RLSARA(BASE(IPOURC))
         CALL RLSARA(BASE(IPROCE))
         CALL RLSARA(BASE(IRAYR3))
         CALL RLSARA(IBASE(INMC3))
      ELSE IF( (ITYGEO.EQ.5).OR.(ITYGEO.EQ.8) .OR.
     1         ((ITYGEO.EQ.20).AND.(ITYCLS.EQ.0)) .OR.
     2         ((ITYGEO.EQ.24).AND.(ITYCLS.EQ.0)) ) THEN
         ITG=4
         CALL SETARA(BASE,MAXPTS,IXX4)
         CALL SETARA(BASE,MAXPTS,IYY4)
         CALL SETARA(IBASE,MAXPTS+1,INMC4)
         CALL SETARA(BASE,MAXPTS,IRAYR4)
         CALL SETARA(IBASE,MAXPTS,IMAIL)
         CALL SETARA(IBASE,MAXZ,IIZMAI)
         CALL SETARA(BASE,MAXZ,IRZMAI)
         CALL SETARA(IBASE,MAXJ,IIFR)
         CALL SETARA(BASE,MAXJ,IALB)
         CALL SETARA(IBASE,MAXPTS,IINUM)
         CALL SETARA(IBASE,MAXJ,IMIX)
         CALL SETARA(BASE,MAXJ,IDVX)
         CALL SETARA(IBASE,MAXPTS,IIGEN)
         IQUAD(1)=JQUA2(1)
         IQUAD(2)=JQUA2(2)
         IQUAD(3)=JQUA1
         IQUAD(4)=JQUA1
*
         CALL SETARA(BASE,MAXPTS,IPOURC)
         CALL SETARA(BASE,MAXPTS,IIORI)
         CALL SYBEUR(MAXPTS,MAXPTS,MAXJ,MAXZ,IPGEOM,NREG,IR,MAT,VOL,
     1   ILK,IMPX,IHEX,NCOUR,LMAIL,NMCEL,NMERGE,NGEN,IJAT,MULTC,IWIGN,
     2   IHALT,ILIGN,INORM,IRECT,IQW,IQUAD,BASE(IXX4),BASE(IYY4),
     3   IBASE(INMC4),BASE(IRAYR4),IBASE(IMAIL),IBASE(IIZMAI),
     4   BASE(IRZMAI),IBASE(IIFR),BASE(IALB),IBASE(IINUM),IBASE(IMIX),
     5   BASE(IDVX),IBASE(IIGEN),BASE(IPOURC),BASE(IIORI))
         CALL RLSARA(BASE(IIORI))
         CALL RLSARA(BASE(IPOURC))
*
         CALL XDISET(ISTATE,NSTATE,0)
         ISTATE(1)=IHEX
         ISTATE(2)=MULTC
         ISTATE(3)=IWIGN
         ISTATE(4)=NMCEL
         ISTATE(5)=NMERGE
         ISTATE(6)=NGEN
         ISTATE(7)=IJAT
         ISTATE(8)=IQUAD(1)
         ISTATE(9)=IQUAD(2)
         ISTATE(10)=IQUAD(3)
         ISTATE(11)=IQUAD(4)
         ISTATE(12)=INORM
         ISTATE(13)=IQW
         ISTATE(14)=NCOUR
         ISTATE(15)=LMAIL
         IRDIM=IBASE(INMC4+NGEN)
         CALL LCMSIX(IPTRK,'EURYDICE',1)
         CALL LCMPUT(IPTRK,'PARAM   ',15,1,ISTATE)
         CALL LCMPUT(IPTRK,'XX',NGEN,2,BASE(IXX4))
         CALL LCMPUT(IPTRK,'YY',NGEN,2,BASE(IYY4))
         CALL LCMPUT(IPTRK,'NMC',1+NGEN,1,IBASE(INMC4))
         CALL LCMPUT(IPTRK,'RAYRE',IRDIM,2,BASE(IRAYR4))
         CALL LCMPUT(IPTRK,'MAIL',NGEN,1,IBASE(IMAIL))
         IF(LMAIL.GT.0) THEN
            CALL LCMPUT(IPTRK,'ZMAILI',LMAIL,1,IBASE(IIZMAI))
            CALL LCMPUT(IPTRK,'ZMAILR',LMAIL,2,BASE(IRZMAI))
         ENDIF
         CALL LCMPUT(IPTRK,'IFR',NCOUR*NMCEL,1,IBASE(IIFR))
         CALL LCMPUT(IPTRK,'ALB',NCOUR*NMCEL,2,BASE(IALB))
         CALL LCMPUT(IPTRK,'INUM',NMCEL,1,IBASE(IINUM))
         CALL LCMPUT(IPTRK,'MIX',NCOUR*NMERGE,1,IBASE(IMIX))
         CALL LCMPUT(IPTRK,'DVX',NCOUR*NMERGE,2,BASE(IDVX))
         CALL LCMPUT(IPTRK,'IGEN',NMERGE,1,IBASE(IIGEN))
         CALL LCMSIX(IPTRK,' ',2)
         CALL RLSARA(IBASE(IIGEN))
         CALL RLSARA(BASE(IDVX))
         CALL RLSARA(IBASE(IMIX))
         CALL RLSARA(IBASE(IINUM))
         CALL RLSARA(BASE(IALB))
         CALL RLSARA(IBASE(IIFR))
         CALL RLSARA(BASE(IRZMAI))
         CALL RLSARA(IBASE(IIZMAI))
         CALL RLSARA(IBASE(IMAIL))
         CALL RLSARA(BASE(IRAYR4))
         CALL RLSARA(IBASE(INMC4))
         CALL RLSARA(BASE(IYY4))
         CALL RLSARA(BASE(IXX4))
      ELSE
         CALL XABORT('SYBTRK: INVALID GEOMETRY MODULE.')
      ENDIF
*
      IF(ITYGDH.EQ.1) THEN
*        DOUBLE HETEROGENEITY OPTION:
         ITGOLD=ITG
         ITG=10
         CALL LCMLEN(IPGEOM,'NS',NG,ITYLCM)
         CALL SETARA(IBASE,NG,INS)
         CALL LCMGET(IPGEOM,'NS',IBASE(INS))
         NSMAX=0
         DO 25 I=1,NG
   25    NSMAX=MAX(NSMAX,IBASE(INS+I-1))
*
         CALL SETARA(IBASE,NREG,IIBI)
         CALL SETARA(BASE,NG*(1+NSMAX),IRS)
         CALL SETARA(BASE,NG*IR,IFRACT)
         CALL SETARA(BASE,NG*NSMAX,IVOLK)
*
         NREG2=NREG
         IR2=IR
         DO 30 IKK=1,NREG2
   30    IBASE(IIBI+IKK-1)=MAT(IKK)
         CALL SETARA(BASE,IR2,IMILIE)
         CALL SETARA(BASE,IR2,IIDIL)
         CALL SETARA(BASE,NSMAX*NG*IR2,IITEM)
         CALL SETARA(BASE,IR2,IFTEMP)
         CALL READBH(MAXPTS,IPGEOM,IR,IR2,NREG,NREG2,MAT,VOL,NG,
     1   NSMAX,MICRO,IBASE(INS),IBASE(IIBI),BASE(IRS),BASE(IFRACT),
     2   BASE(IVOLK),IMPX,BASE(IMILIE),BASE(IIDIL),BASE(IITEM),
     3   BASE(IFTEMP))
         CALL RLSARA(BASE(IFTEMP))
         CALL RLSARA(BASE(IITEM))
         CALL RLSARA(BASE(IIDIL))
         CALL RLSARA(BASE(IMILIE))
         IR1=IR
         IF(IMPX.GE.1) WRITE (6,'(/30H QUADRATURE PARAMETER FOR THE ,
     1   17HMICRO STRUCTURE =,I2/)') IQUA10
*
         CALL XDISET(ISTATE,NSTATE,0)
         ISTATE(1)=IR1
         ISTATE(2)=IR2
         ISTATE(3)=NREG2
         ISTATE(4)=NG
         ISTATE(5)=NSMAX
         ISTATE(6)=ITGOLD
         ISTATE(7)=MICRO
         ISTATE(8)=IQUA10
         CALL LCMSIX(IPTRK,'BIHET',1)
         CALL LCMPUT(IPTRK,'PARAM',8,1,ISTATE)
         CALL LCMPOF(IPTRK,'NS',NG,1,INS)
         CALL LCMPOF(IPTRK,'IBI',NREG2,1,IIBI)
         CALL LCMPOF(IPTRK,'RS',NG*(1+NSMAX),2,IRS)
         CALL LCMPOF(IPTRK,'FRACT',NG*IR2,2,IFRACT)
         CALL LCMPOF(IPTRK,'VOLK',NG*NSMAX,2,IVOLK)
         CALL LCMSIX(IPTRK,' ',2)
      ENDIF
      NUN=NREG
      DO 40 I=1,NREG
   40 IDL(I)=I
      IF(IMPX.GT.5) THEN
         I1=1
         DO 50 I=1,(NREG-1)/8+1
         I2=I1+7
         IF(I2.GT.NREG) I2=NREG
         WRITE (6,620) (J,J=I1,I2)
         WRITE (6,630) (MAT(J),J=I1,I2)
         WRITE (6,640) (IDL(J),J=I1,I2)
         WRITE (6,650) (VOL(J),J=I1,I2)
   50    I1=I1+8
      ENDIF
*
* SAVE GENERAL TRACKING INFORMATION.
      CALL XDISET(ISTATE,NSTATE,0)
      ISTATE(1)=NREG
      ISTATE(2)=NUN
      IF(ILK) THEN
         ISTATE(3)=0
      ELSE
         ISTATE(3)=1
      ENDIF
      ISTATE(4)=IR
      CALL LCMPUT(IPTRK,'MATCOD',NREG,1,MAT)
      CALL LCMPUT(IPTRK,'VOLUME',NREG,2,VOL)
      CALL LCMPUT(IPTRK,'KEYFLX',NREG,1,IDL)
*
* SAVE SYBIL SPECIFIC TRACKING INFORMATION.
      ISTATE(6)=1
      ISTATE(7)=ITG
      ISTATE(8)=MAXZ
      ISTATE(9)=MAXJ
      CALL LCMPUT(IPTRK,'STATE-VECTOR',NSTATE,1,ISTATE)
      RETURN
*
  620 FORMAT (///11H REGION    ,8(I8,6X,1HI))
  630 FORMAT (   11H MIXTURE   ,8(I8,6X,1HI))
  640 FORMAT (   11H POINTER   ,8(I8,6X,1HI))
  650 FORMAT (   11H VOLUME    ,8(1P,E13.6,2H I))
      END
