*DECK TRFICF
      SUBROUTINE TRFICF(IPSYS ,IPTRK ,IPBTF ,IPRNTF,IDIR  ,NREGIO,
     >                  NUNKNO,MATCOD,VOLUME,KEYFLX,
     >                  FUNKNO,SUNKNO,TITRE)
C
C---------------------------  TRFICF  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     :  TRFICF
C      USE      :  SOLVE ONE GROUP TRANSPORT EQUATION FOR FLUXES
C                  USING THE SCATTERING MODIFIED CP MATRIX.
C      MODIFIED :  91-03-19
C      AUTHOR   :  G.MARLEAU
C
C  2- ROUTINE PARAMETERS:
C    INPUT
C      IPSYS    : POINTER TO THE PIJ                 I
C      IPTRK    : POINTER TO THE TRACKING            I
C      IPBTF    : POINTER TO BINARY TRACKING FILE    I
C      IPRNTF   : PRINT SELECTION FOR FLUX MODULES   I
C      IDIR     : DIRECTION FOR PC                   I
C                  = 0 FOR PIJ OR WIJ
C                  = K FOR PIJK OR WIJK K=1,2,3
C      NREGIO   : NUMBER OF REGIONS CONSIDERED       I
C      NUNKNO   : NUMBER OF UNKNOWN IN THE SYSTEM    I
C      MATCOD   : MIXTURE CODE IN REGION             I(NREGIO)
C      VOLUME   : VOLUME OF REGION                   R(NREGIO)
C      KEYFLX   : FLUX ELEMENTS IN UNKNOWN SYSTEM    I(NREGIO)
C      FUNKNO   : UNKNOWN VECTOR SOLVED FOR          R(NUNKNO)
C      SUNKNO   : SOURCE FOR SYSTEM OF UNKNOWN       R(NUNKNO)
C      TITRE    : TITLE                              C*72
C
C--------------------------    TRFICF    ------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,NAMSBR='TRFICF')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPSYS,IPTRK,IPBTF,IPRNTF,IDIR,NREGIO,NUNKNO
      CHARACTER   TITRE*72
      INTEGER     MATCOD(NREGIO),KEYFLX(NREGIO)
      REAL        VOLUME(NREGIO),FUNKNO(NUNKNO),SUNKNO(NUNKNO)
C----
C  FUNCTION
C----
      INTEGER     LCMIOF
C----
C  MEMORY ALLOCATION
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     ICPMAT
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   NAMT*12,NAMLCM*12,NAMMY*12
      INTEGER     ILCMLN,ILCMTY,IREG,JREG,JCPMAT,IPOS,JPOS
      LOGICAL     LCM
C----
C  DATA
C----
      CHARACTER   CNS(0:3)*1,CNFDIR(0:3)*9
      SAVE        CNS,CNFDIR
      DATA        CNS
     >   /'-','1','2','3'/
      DATA        CNFDIR
     >   /'F L U X  ','C U R - X','C U R - Y','C U R - Z'/
C----
C  ALLOCATE STORAGE AND READ SCATTERING MODIFIED COLLISION PROBABILITIES
C----
      NAMT=' '
      CALL LCMNXT(IPSYS,NAMT,NAMLCM,NAMMY,LCM)
      CALL LCMLEN(IPSYS,'DRAGON'//CNS(IDIR)//'PCSCT',ILCMLN,ILCMTY)
      IF(ILCMLN .GT. 0 .AND. LCM) THEN
        ICPMAT=LCMIOF(IPSYS,'DRAGON'//CNS(IDIR)//'PCSCT')
      ELSE IF(ILCMLN .GT. 0) THEN
        CALL SETARA(RBASE,NREGIO*NREGIO,ICPMAT)
        CALL LCMGET(IPSYS,'DRAGON'//CNS(IDIR)//'PCSCT',RBASE(ICPMAT))
      ELSE
        CALL XABORT(NAMSBR//
     >': RECORD DRAGON'//CNS(IDIR)//'PCSCT ABSENT FROM LCM')
      ENDIF
C----
C  PRINT SOURCES WHEN REQUIRED
C----
      IF(IPRNTF .GE. 5) THEN
        WRITE(IOUT,'(12H  SOURCES : ,3X,A9)') CNFDIR(IDIR)
        WRITE(IOUT,'(1P,6(5X,E15.7))')
     >    (SUNKNO(KEYFLX(IREG)),IREG=1,NREGIO)
      ENDIF
C----
C  SOLVE TRANSPORT EQUATION
C----
      JCPMAT=ICPMAT-1
      DO 10 IPOS=1,NUNKNO
        FUNKNO(IPOS)=0.0
 10   CONTINUE
      DO 30 IREG=1,NREGIO
        IPOS=KEYFLX(IREG)
        DO 20 JREG=1,NREGIO
          JPOS=KEYFLX(JREG)
          FUNKNO(JPOS)=FUNKNO(JPOS)+SUNKNO(IPOS)*RBASE(JCPMAT+JREG)
 20     CONTINUE
        JCPMAT=JCPMAT+NREGIO
 30   CONTINUE
C----
C  PRINT FLUXES WHEN REQUIRED
C----
      IF(IPRNTF .GE. 5) THEN
        WRITE(IOUT,6000) NAMSBR,CNFDIR(IDIR)
        WRITE(IOUT,6001)
     >    (FUNKNO(KEYFLX(IREG)),IREG=1,NREGIO)
      ENDIF
      IF(.NOT. LCM) CALL RLSARA(RBASE(ICPMAT))
      RETURN
C----
C  FORMATS
C----
 6000 FORMAT(1X,A6,' S O L U T I O N  : ',A9)
 6001 FORMAT(1P,6(5X,E15.7))
      END
