*DECK XDRCRE
      SUBROUTINE XDRCRE(NAMMOD,IBEAF )
*
*-----------------------------------------------------------------------
*
*Purpose:
* To print DRAGON credits.
*
*Copyright:
* Copyright (C) 2004 Ecole Polytechnique de Montreal
*
*Author(s): G. Marleau
*
*Parameters: input
* NAMMOD  name of DRAGON module.
* IBEAF   flag for beginning or finishing module where
*         \begin{itemize} 
*         \item IBEAF=1  before module execution;
*         \item IBEAF=-1 after module execution.
*         \end{itemize} 
*
*-----------------------------------------------------------------------
*
      IMPLICIT         NONE
*----
*  SUBROUTINE ARGUMENTS
*----
      CHARACTER        NAMMOD*12
      INTEGER          IBEAF
*----
*  LOCAL PARAMETERS
*----
      INTEGER          IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,NAMSBR='XDRCRE')
*----
*  LOCAL VARIABLES
*----
      CHARACTER        USE*72,AUT*72
      INTEGER          ICOPYR
*----
*  PRINT CREDITS
*----
      ICOPYR=0
      IF(IBEAF .EQ. 1) THEN
        WRITE(IOUT,6000) NAMMOD
        IF     (NAMMOD .EQ.  'ASM:        ') THEN      
          USE='Built CP and IC system matrices'
          AUT='A. Hebert, G. Marleau, R. Roy'
        ELSE IF(NAMMOD .EQ.  'CFC:        ') THEN      
          USE='Create feedback coefficients reactor database'
          AUT='T. Sissaoui'
        ELSE IF(NAMMOD .EQ.  'CPO:        ') THEN      
          USE='Create standard reactor database'
          AUT='A. Hebert'
        ELSE IF(NAMMOD .EQ.  'EDI:        ') THEN      
          USE='Editing module'
          AUT='A. Hebert, G. Marleau'
        ELSE IF(NAMMOD .EQ.  'EVO:        ') THEN      
          USE='Isotopic depletion and fuel burnup'
          AUT='A. Hebert'
        ELSE IF(NAMMOD .EQ.  'EXCELL:     ') THEN      
          USE='3-D EXCELT module combined with ASM'
          AUT='R. Roy'
        ELSE IF(NAMMOD .EQ.  'EXCELT:     ') THEN      
          USE='EXCELL tracking in 2-D and 3-D'
          AUT='G. Marleau, M. Ouisloumen, R. Roy'
        ELSE IF(NAMMOD .EQ.  'FLU:        ') THEN      
          USE='Solve CP and IC equations for the flux'
          AUT='T. Courau, A. Hebert, G. Marleau, I. Petrovic'
        ELSE IF(NAMMOD .EQ.  'GEO:        ') THEN      
          USE='Geometry definition'
          AUT='A. Hebert'
        ELSE IF(NAMMOD .EQ.  'INFO:       ') THEN      
          USE='Information on water, UO2 and THO2'
          AUT='R. Roy'
        ELSE IF(NAMMOD .EQ.  'JPMT:       ') THEN      
          USE='JPM 2-D tracking'
          AUT='A. Hebert, G. Marleau, M. OUISLOUMEN'
        ELSE IF(NAMMOD .EQ.  'LIB:        ') THEN      
          USE='Microscopic cross section library processing'
          AUT='A. Hebert, G. Marleau'
        ELSE IF(NAMMOD .EQ.  'MAC:        ') THEN      
          USE='Macroscopic cross section precessor'
          AUT='G. Marleau'
        ELSE IF(NAMMOD .EQ.  'MOCC:       ') THEN      
          USE='Method of cyclic characteristicsin 2-D'
          AUT='R. Roy, M. Assawaroongruengchot'
        ELSE IF(NAMMOD .EQ.  'MRG:        ') THEN      
          USE='Merge EXCELL tracking file'
          AUT='G. Marleau'
        ELSE IF(NAMMOD .EQ.  'PSP:        ') THEN      
          USE='Generate PostScript graphics'
          AUT='K.E. Kohler, G. Marleau'
          ICOPYR=1
        ELSE IF(NAMMOD .EQ.  'SHI:        ') THEN      
          USE='Self shielding by improved Stammler method'
          AUT='A. Hebert'
        ELSE IF(NAMMOD .EQ.  'SYBILT:     ') THEN      
          USE='SYBIL 2-D tracking'
          AUT='A. Hebert'
        ELSE IF(NAMMOD .EQ.  'HST:        ') THEN      
          USE='Cell history module'
          AUT='G. Marleau, E. Varin'
        ELSE IF(NAMMOD .EQ.  'SAD:        ') THEN      
          USE='Compute generalized adjoint sources and fluxes'
          AUT='T. Courau, G. Marleau, M. Assawaroongruengchot'
        ELSE IF(NAMMOD .EQ.  'PER:        ') THEN      
          USE='Compute perturbation and fluxed'
          AUT='T. Courau, G. Marleau, M. Assawaroongruengchot'
        ELSE IF(NAMMOD .EQ.  'MCU:        ') THEN      
          USE='Universal 3-D characteristics solver'
          AUT='M. Dahmani, R. Roy, G.J. Wu'
        ELSE IF(NAMMOD .EQ.  'NXT:        ') THEN      
          USE='New tracking in 2-D and 3-D (compatible with EXCELT)'
          AUT='G. Marleau'
        ELSE IF(NAMMOD .EQ.  'TLM:        ') THEN      
          USE='Generate Matlab line tracing file'
          AUT='C. Plamondon, G. Marleau'
        ELSE IF(NAMMOD .EQ.  'SUS:        ') THEN      
          USE='Generate SUSD3D flux and adjoint files'
          AUT='G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'NDIST:      ') THEN      
          USE='Generate normal distribution of error'
          AUT='G. MARLEAU'
        ELSE
          USE='No description available for this module'
          AUT='No author provided for this module'
        ENDIF
        WRITE(IOUT,6100) USE,AUT
        IF(ICOPYR .EQ. 1) THEN
          WRITE(IOUT,6111)
        ELSE
          WRITE(IOUT,6110)
        ENDIF
      ELSE
        WRITE(IOUT,6001) NAMMOD
      ENDIF
      RETURN
*----
*  FORMATS
*----
 6000 FORMAT('->@BEGIN MODULE : ',A12)
 6001 FORMAT('->@END MODULE   : ',A12)
 6100 FORMAT('->@DESCRIPTION  : ',A72/
     >       '->@CREDITS      : ',A72)
 6110 FORMAT('->@COPYRIGHTS   : ECOLE POLYTECHNIQUE DE MONTREAL ')
 6111 FORMAT('->@COPYRIGHTS   : ECOLE POLYTECHNIQUE DE MONTREAL '/
     >       '                  K.E. KOHLER FOR PSPLOT          ')
      END  
