      SUBROUTINE LCMOP(IPLIST,NAMP,IMP,MEDIUM,IMPX)
*
*-----------------------------------------------------------------------
*
* OPEN AN EXISTING OR CREATE A NEW LINKED LIST.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE EXISTING LINKED LIST IF IMP=1 OR IMP=2.
*    NAMP : CHARACTER*12 NAME OF THE LINKED LIST IF IMP=0.
*     IMP : =0 TO CREATE A NEW LIST; =1 TO MODIFY AN EXISTING LIST;
*           =2 TO ACCESS AN EXISTING LIST IN READ-ONLY MODE.
*  MEDIUM : =1 USE A LINKED LIST; =2 USE AN XSM FILE.
*    IMPX : IF IMPX=0, WE SUPPRESS PRINTING ON LCMOP.
*
* OUTPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE NEW LINKED LIST IF IMP=0.
*    NAMP : CHARACTER*12 NAME OF THE LINKED LIST IF IMP=1 OR IMP=2.
*
* INTERNAL VARIABLES:
*   PNEXT : POINTER TO THE FIRST ELEMENT IN THE ACTIVE LINKED LIST.
*   PFATH : POINTER TO THE FIRST ELEMENT IN THE PARENT LINKED LIST.
*    IPOS : POSITION OF THE DIRECTORY ELEMENT IN THE PARENT LINKED LIST.
*  PNEXT0 : VALUE OF PNEXT AT THE READ-ONLY OPEN TIME.
*  PFATH0 : VALUE OF PFATH AT THE READ-ONLY OPEN TIME.
*    MODE : =0 THE LINKED LIST IS CLOSED.
*           =1 THE LINKED LIST IS OPEN FOR MODIFICATIONS.
*           =2 THE LINKED LIST IS OPEN IN READ-ONLY MODE.
*
*------------------------------------- AUTHOR: A. HEBERT ; 21/10/93 ----
*
      PARAMETER (MAXEL=40,LFNODE=12,LHASH=251)
      INTEGER PFIRST
      PARAMETER (IHEAD=0,IHNAM=1,INEXT=4,IFATH=5,IDIR=6,INEXT0=7,
     1 IFATH0=8,IMODE=9)
      CHARACTER NAMP*(*),HNAME*12,HSMG*131
      COMMON IBASE(1)
*
      IF(MEDIUM.EQ.2) THEN
*        USE A XSM FILE TO STORE INFORMATION
         CALL XSMOP(IPLIST,NAMP,IMP,IMPX)
         RETURN
      ELSE IF(MEDIUM.NE.1) THEN
         WRITE(HSMG,'(23HLCMOP: INVALID MEDIUM (,I3,2H).)') MEDIUM
         CALL XABORT(HSMG)
      ELSE IF((IMP.LT.0).OR.(IMP.GT.2)) THEN
         HNAME=NAMP
         WRITE(HSMG,'(23HLCMOP: INVALID ACTION (,I3,15H) ON LINKED LIS,
     1   3HT '',A12,2H''.)') IMP,HNAME
         CALL XABORT(HSMG)
      ENDIF
      IF(IMP.EQ.0) THEN
         HNAME=NAMP
         CALL SETARA(IBASE,LFNODE,PFIRST)
         READ(HNAME,'(3A4)') (IBASE(PFIRST+IHNAM+I),I=0,2)
         IBASE(PFIRST+IHEAD)=100
         IBASE(PFIRST+IFATH)=-1
         IBASE(PFIRST+IDIR)=-1
         IBASE(PFIRST+IMODE)=1
         IPLIST=PFIRST
         CALL SETARA(IBASE,2+LHASH+10*MAXEL,IPNODE)
         IBASE(PFIRST+INEXT)=IPNODE
         IBASE(IPNODE)=MAXEL
         IBASE(IPNODE+1)=0
         DO 10 I=1,LHASH
   10    IBASE(IPNODE+I+1)=0
      ELSE
         PFIRST=IPLIST
         WRITE(HNAME,'(3A4)') (IBASE(PFIRST+IHNAM+I),I=0,2)
         IF(IBASE(PFIRST+IHEAD).NE.100) THEN
            WRITE(HSMG,'(24HLCMOP: THE LINKED LIST '',A12,8H'' WITH A,
     1      8HDDRESS =,I10,20H HAS A WRONG HEADER.)') HNAME,IPLIST
            CALL XABORT(HSMG)
         ELSE IF(IBASE(PFIRST+IMODE).NE.0) THEN
            WRITE(HSMG,'(24HLCMOP: THE LINKED LIST '',A12,9H'' IS ALRE,
     1      9HADY OPEN.)') HNAME
            CALL XABORT(HSMG)
         ENDIF
         NAMP=HNAME
         IBASE(PFIRST+IMODE)=IMP
      ENDIF
      IF(IBASE(PFIRST+IMODE).EQ.2) THEN
         IBASE(PFIRST+INEXT0)=IBASE(PFIRST+INEXT)
         IBASE(PFIRST+IFATH0)=IBASE(PFIRST+IFATH)
      ENDIF
      IF((IMPX.GT.0).AND.(IMP.EQ.0)) THEN
         WRITE (6,'(/38H LCMOP: OPEN A NEW LINKED LIST NAMED '',A12,
     1   16H'' WITH ADDRESS =,I12,1H.)') HNAME,IPLIST
      ELSE IF((IMPX.GT.0).AND.(IMP.EQ.1)) THEN
         WRITE (6,'(/36H LCMOP: MODIFY A LINKED LIST NAMED '',A12,
     1   16H'' WITH ADDRESS =,I12,1H.)') HNAME,IPLIST
      ELSE IF((IMPX.GT.0).AND.(IMP.EQ.2)) THEN
         WRITE (6,'(/34H LCMOP: OPEN A LINKED LIST NAMED '',A12,
     1   16H'' WITH ADDRESS =,I12,19H IN READ-ONLY MODE.)') HNAME,IPLIST
      ENDIF
      RETURN
      END
