      SUBROUTINE XSMDIR(IND,IFILE,CMT,NMT,LINK,IROOT,MYNAME,IOFSET,
     1 JLONG,JTYPE,IDIR)
*
*-----------------------------------------------------------------------
*
* IMPORT OR EXPORT A DIRECTORY USING THE KDI UTILITY.
*
* INPUT PARAMETERS:
*  IND   : =1 FOR IMPORT ; =2 FOR EXPORT.
*  IFILE  : UNIT NUMBER OF THE XSM FILE.
*  CMT    : LIST OF CHARACTER*12 NAMES OF EACH BLOCK (RECORD OR
*           DIRECTORY) THAT BELONG TO THE ACTIVE DIRECTORY EXTENT.
*  NMT    : NUMBER OF BLOCKS STORED ON THE ACTIVE DIRECTORY EXTENT.
*  LINK   : OFFSET OF THE NEXT DIRECTORY EXTENT.
*  IROOT  : OFFSET OF ANY PARENT DIRECTORY EXTENT.
*  MYNAME : CHARACTER*12 NAME OF THE ACTIVE DIRECTORY. MYNAME='/' FOR
*           THE ROOT LEVEL.
*  IOFSET : OFFSET LIST (POSITION OF THE FIRST ELEMENT OF EACH BLOCK
*           THAT BELONG TO THE ACTIVE DIRECTORY EXTENT).
*  JLONG  : LENGTH OF EACH RECORD (JLONG=0 FOR A DIRECTORY) THAT BELONG
*           TO THE ACTIVE DIRECTORY EXTENT.
*  JTYPE  : TYPE OF EACH BLOCK THAT BELONG TO THE ACTIVE DIRECTORY
*           EXTENT.
*  IDIR   : OFFSET OF THE ACTIVE DIRECTORY EXTENT.
*
*------------------------------------- AUTHOR: A. HEBERT ; 30/09/86 ----
*
      CHARACTER*(*) CMT(*),MYNAME
      CHARACTER HEADER*4,CIRC*8,HGAR*12
      PARAMETER (IOFMAX=30,IWRD=3)
      DIMENSION  IOFSET(*),JLONG(*),JTYPE(*),IBUF(IWRD)
*
      IF (IND.EQ.1) THEN
         CALL KDIGET(IFILE,IBUF,IDIR,1,IRC)
         IF (IRC.NE.0) GO TO 40
         WRITE (HEADER,'(A4)') IBUF(1)
         IF (HEADER.NE.'$$$$') GO TO 30
         CALL KDIGET(IFILE,IOFMA2,IDIR+1,1,IRC)
         CALL KDIGET(IFILE,NMT,IDIR+2,1,IRC)
         IF (NMT.GT.IOFMAX) GO TO 30
         CALL KDIGET(IFILE,LINK,IDIR+3,1,IRC)
         CALL KDIGET(IFILE,IROOT,IDIR+4,1,IRC)
         CALL KDIGET(IFILE,IBUF,IDIR+5,IWRD,IRC)
         WRITE (HGAR(:4),'(A4)') IBUF(1)
         WRITE (HGAR(5:8),'(A4)') IBUF(2)
         WRITE (HGAR(9:),'(A4)') IBUF(3)
         MYNAME=HGAR
         IF (NMT.EQ.0) RETURN
         IBASE=IDIR+5+IWRD
         CALL KDIGET(IFILE,IOFSET,IBASE,NMT,IRC)
         CALL KDIGET(IFILE,JLONG,IBASE+IOFMA2,NMT,IRC)
         CALL KDIGET(IFILE,JTYPE,IBASE+2*IOFMA2,NMT,IRC)
         DO 10 I=1,NMT
         CALL KDIGET(IFILE,IBUF,IBASE+3*IOFMA2+(I-1)*IWRD,IWRD,IRC)
         IF (IRC.NE.0) GO TO 40
         WRITE (HGAR(:4),'(A4)') IBUF(1)
         WRITE (HGAR(5:8),'(A4)') IBUF(2)
         WRITE (HGAR(9:),'(A4)') IBUF(3)
   10    CMT(I)=HGAR
      ELSE IF (IND.EQ.2) THEN
         HEADER='$$$$'
         READ (HEADER,'(A4)') IBUF(1)
         CALL KDIPUT(IFILE,IBUF,IDIR,1,IRC)
         IF (IRC.NE.0) GO TO 50
         CALL KDIPUT(IFILE,IOFMAX,IDIR+1,1,IRC)
         CALL KDIPUT(IFILE,NMT,IDIR+2,1,IRC)
         CALL KDIPUT(IFILE,LINK,IDIR+3,1,IRC)
         CALL KDIPUT(IFILE,IROOT,IDIR+4,1,IRC)
         HGAR=MYNAME
         READ (HGAR(:4),'(A4)') IBUF(1)
         READ (HGAR(5:8),'(A4)') IBUF(2)
         READ (HGAR(9:),'(A4)') IBUF(3)
         CALL KDIPUT(IFILE,IBUF,IDIR+5,IWRD,IRC)
         IF (NMT.EQ.0) RETURN
         IBASE=IDIR+5+IWRD
         CALL KDIPUT(IFILE,IOFSET,IBASE,NMT,IRC)
         CALL KDIPUT(IFILE,JLONG,IBASE+IOFMAX,NMT,IRC)
         CALL KDIPUT(IFILE,JTYPE,IBASE+2*IOFMAX,NMT,IRC)
         DO 20 I=1,NMT
         HGAR=CMT(I)
         READ (HGAR(:4),'(A4)') IBUF(1)
         READ (HGAR(5:8),'(A4)') IBUF(2)
         READ (HGAR(9:),'(A4)') IBUF(3)
         CALL KDIPUT(IFILE,IBUF,IBASE+3*IOFMAX+(I-1)*IWRD,IWRD,IRC)
         IF (IRC.NE.0) GO TO 50
   20    CONTINUE
      ENDIF
      RETURN
*
* ABORT ON FATAL ERRORS
   30 WRITE(6,'(/37H XSMDIR: UNABLE TO RECOVER DIRECTORY.)')
      STOP
   40 WRITE(CIRC,'(I8)') IRC
      WRITE(6,'(A35)') 'XSMDIR: (KDIGET) ERROR NO. '//CIRC
      STOP
   50 WRITE(CIRC,'(I8)') IRC
      WRITE(6,'(A35)') 'XSMDIR: (KDIPUT) ERROR NO. '//CIRC
      STOP
      END
