*DECK ALDLFV
      SUBROUTINE ALDLFV (NG,L4,ASS,MU1,T)
*
*-----------------------------------------------------------------------
*
* IN-PLACE L-D-L(T) FACTORIZATION OF *NG* SYMMETRIC POSITIVE DEFINITE
* MATRIX IN COMPRESSED DIAGONAL STORAGE MODE.
*
* INPUT PARAMETERS:
*    L4 : ORDER OF THE COEFFICIENT MATRIX.
*   ASS : COEFFICIENT MATRIX IN COMPRESSED DIAGONAL STORAGE MODE.
*         A(I,J)=ASS(MU1(I)-I+J) IF J.LE.I AND J.GT.I+MU1(I-1)-MU1(I)
*               =A(J,I)          IF I.LT.J
*               =0.0             ELSE
*         DIMENSION ASS(NG,MU1(L4)-MU1(1)+1)
*   MU1 : POSITION OF EACH DIAGONAL ELEMENT IN VECTOR ASS.
*         DIMENSION MU1(L4)
*     T : WORKING-SPACE VECTOR. DIMENSION T(NG,2)
*
* OUTPUT PARAMETER:
*   ASS : LU FACTORS.
*
*-------------------------------------- MODIFY: R. ROY ;    17/09/96 ---
*
      IMPLICIT NONE
      INTEGER NG,L4,MU1(*)
      DOUBLE PRECISION ASS(NG,*),T(NG,2)
      INTEGER IG,K,K1,KM,KMM,KLL,I,IM,IMIN,J,I1
      DO IG= 1,NG
         ASS(IG,MU1(1))=1.D0/ASS(IG,MU1(1))
      ENDDO
      IF( L4.NE.1 )THEN
        DO K=2,L4
          KLL= K-1
          K1= MU1(K)-K
          KM= MU1(K-1)+1-K1
          KMM= KM+1
          IF (KMM-K .LE. 0) THEN
            IF (KMM-K .LT. 0) THEN
              DO I=KMM,KLL
                DO IG=1,NG
                  T(IG,1)=ASS(IG,K1+I)
                  ASS(IG,K1+I)=0.0D0
                  T(IG,2)=0.0D0
                ENDDO
                I1=MU1(I)-I
                IM=MU1(I-1)+1-I1
                IMIN=MAX0(IM,KM)
                DO J=IMIN,I
                  DO IG=1,NG
                    T(IG,2)=T(IG,2)+ASS(IG,K1+J)*ASS(IG,I1+J)
                  ENDDO
                ENDDO
                DO IG=1,NG
                  ASS(IG,K1+I)=T(IG,1)-T(IG,2)
                ENDDO
              ENDDO
            ENDIF
            DO IG=1,NG
              T(IG,2)=0.0D0
            ENDDO
            DO I=KM,KLL
              DO IG=1,NG
                T(IG,1)=ASS(IG,K1+I)
                ASS(IG,K1+I)=T(IG,1)*ASS(IG,MU1(I))
                T(IG,2)=T(IG,2)+T(IG,1)*ASS(IG,K1+I)
              ENDDO
            ENDDO
            DO IG=1,NG
              ASS(IG,MU1(K))=ASS(IG,MU1(K))-T(IG,2)
            ENDDO
          ENDIF
          DO IG=1,NG
             ASS(IG,MU1(K))=1.D0/ASS(IG,MU1(K))
          ENDDO
        ENDDO
      ENDIF
      RETURN
      END
